scala.xml

# NodeBuffer

#### class NodeBuffer extends ArrayBuffer[Node]

This class acts as a Buffer for nodes. If it is used as a sequence of nodes `Seq[Node]`, it must be ensured that no updates occur after that point, because `scala.xml.Node` is assumed to be immutable.

Despite this being a sequence, don't use it as key in a hashtable. Calling the hashcode function will result in a runtime error.

Source
  NodeBuffer.scala
Version

  1.0

Linear Supertypes
ArrayBuffer[Node], Serializable, Serializable, CustomParallelizable[Node, ParArray[Node]], ResizableArray[Node], IndexedSeq[Node], IndexedSeq[Node], Builder[Node, ArrayBuffer[Node]], IndexedSeqOptimized[Node, ArrayBuffer[Node]], IndexedSeqOptimized[Node, ArrayBuffer[Node]], IndexedSeqLike[Node, ArrayBuffer[Node]], IndexedSeqLike[Node, ArrayBuffer[Node]], Buffer[Node], BufferLike[Node, ArrayBuffer[Node]], Subtractable[Node, ArrayBuffer[Node]], Scriptable[Node], Shrinkable[Node], Growable[Node], Seq[Node], SeqLike[Node, ArrayBuffer[Node]], Cloneable[ArrayBuffer[Node]], Seq[Node], SeqLike[Node, ArrayBuffer[Node]], GenSeq[Node], GenSeqLike[Node, ArrayBuffer[Node]], PartialFunction[Int, Node], (Int) ⇒ Node, Iterable[Node], Iterable[Node], IterableLike[Node, ArrayBuffer[Node]], Equals, GenIterable[Node], GenIterableLike[Node, ArrayBuffer[Node]], Traversable[Node], Mutable, Traversable[Node], GenTraversable[Node], GenericTraversableTemplate[Node, ArrayBuffer], TraversableLike[Node, ArrayBuffer[Node]], GenTraversableLike[Node, ArrayBuffer[Node]], Parallelizable[Node, ParArray[Node]], TraversableOnce[Node], GenTraversableOnce[Node], FilterMonadic[Node, ArrayBuffer[Node]], HasNewBuilder[Node, ArrayBuffer[Node]], AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. NodeBuffer
2. ArrayBuffer
3. Serializable
4. Serializable
5. CustomParallelizable
6. ResizableArray
7. IndexedSeq
8. IndexedSeq
9. Builder
10. IndexedSeqOptimized
11. IndexedSeqOptimized
12. IndexedSeqLike
13. IndexedSeqLike
14. Buffer
15. BufferLike
16. Subtractable
17. Scriptable
18. Shrinkable
19. Growable
20. Seq
21. SeqLike
22. Cloneable
23. Seq
24. SeqLike
25. GenSeq
26. GenSeqLike
27. PartialFunction
28. Function1
29. Iterable
30. Iterable
31. IterableLike
32. Equals
33. GenIterable
34. GenIterableLike
35. Traversable
36. Mutable
37. Traversable
38. GenTraversable
39. GenericTraversableTemplate
40. TraversableLike
41. GenTraversableLike
42. Parallelizable
43. TraversableOnce
44. GenTraversableOnce
45. FilterMonadic
46. HasNewBuilder
47. AnyRef
48. Any

Visibility

1. Public
2. All

### Instance Constructors

1. #### new NodeBuffer()

### Type Members

1. #### class Elements extends BufferedIterator[A] with Serializable

   The class of the iterator returned by the `iterator` method.

2. #### type Self = ArrayBuffer[Node]

   The type implementing this traversable

   The type implementing this traversable

   Attributes
     protected
   Definition Classes
     TraversableLike

3. #### class WithFilter extends FilterMonadic[A, Repr]

   A class supporting filtered operations.

### Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types.

   Equivalent to `x.hashCode` except for boxed numeric types. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### def &+(o: Any): NodeBuffer

   Append given object to this buffer, returns reference on this NodeBuffer for convenience.

   Append given object to this buffer, returns reference on this NodeBuffer for convenience. Some rules apply: If o is null, it is ignored. If it is an Iterator or Iterable, its elements will be added. If o is a node, it is added as it is. If it is anything else, it gets wrapped in an Atom.

   o

     converts to an xml node and adds to this node buffer

   returns

     this nodebuffer

5. #### def ++(xs: GenTraversableOnce[Node]): ArrayBuffer[Node]

   Creates a new collection containing both the elements of this collection and the provided traversable object.

   Creates a new collection containing both the elements of this collection and the provided traversable object.

   xs

     the traversable object.

   returns

     a new collection consisting of all the elements of this collection and `xs`.

   Definition Classes
     BufferLike
   Annotations
     @migration
   Migration

     (Changed in version 2.8.0) `++` creates a new buffer. Use `++=` to add an element from this buffer and return that buffer itself.

6. #### abstract def ++[B](that: GenTraversableOnce[B]): ArrayBuffer[B]

   [use case] Returns a new arraybuffer containing the elements from the left hand operand followed by the elements from the right hand operand.

   [use case]

   Returns a new arraybuffer containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the arraybuffer is the most specific superclass encompassing the element types of the two operands (see example).

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new collection of type `That` which contains all elements of this arraybuffer followed by all elements of `that`.

   Definition Classes
     GenTraversableLike

7. #### def ++[B >: Node, That](that: GenTraversableOnce[B])(implicit bf: CanBuildFrom[ArrayBuffer[Node], B, That]): That

   Returns a new arraybuffer containing the elements from the left hand operand followed by the elements from the right hand operand.

   Returns a new arraybuffer containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the arraybuffer is the most specific superclass encompassing the element types of the two operands (see example).

   Example:

           scala> val a = LinkedList(1)
           a: scala.collection.mutable.LinkedList[Int] = LinkedList(1)

           scala> val b = LinkedList(2)
           b: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

           scala> val c = a ++ b
           c: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

           scala> val d = LinkedList('a')
           d: scala.collection.mutable.LinkedList[Char] = LinkedList(a)

           scala> val e = c ++ d
           e: scala.collection.mutable.LinkedList[AnyVal] = LinkedList(1, 2, a)

   B

     the element type of the returned collection.

   That

     the class of the returned collection. In the standard library configuration, `That` is always `ArrayBuffer[B]` because an implicit of type `CanBuildFrom[ArrayBuffer, B, ArrayBuffer[B]]` is defined in object `ArrayBuffer`.

   that

     the traversable to append.

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`. This is usually the `canBuildFrom` value defined in object `ArrayBuffer`.

   returns

     a new collection of type `That` which contains all elements of this arraybuffer followed by all elements of `that`.

   Definition Classes
     TraversableLike → GenTraversableLike

8. #### def ++:[B >: Node, That](that: Traversable[B])(implicit bf: CanBuildFrom[ArrayBuffer[Node], B, That]): That

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand. It differs from `++` in that the right operand determines the type of the resulting collection rather than the left one.

   Example:

           scala> val x = List(1)
           x: List[Int] = List(1)

           scala> val y = LinkedList(2)
           y: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

           scala> val z = x ++: y
           z: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

   This overload exists because: for the implementation of `++:` we should reuse that of `++` because many collections override it with more efficient versions.

   Since `TraversableOnce` has no `++` method, we have to implement that directly, but `Traversable` and down can use the overload.

   B

     the element type of the returned collection.

   That

     the class of the returned collection. In the standard library configuration, `That` is always `ArrayBuffer[B]` because an implicit of type `CanBuildFrom[ArrayBuffer, B, ArrayBuffer[B]]` is defined in object `ArrayBuffer`.

   that

     the traversable to append.

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`. This is usually the `canBuildFrom` value defined in object `ArrayBuffer`.

   returns

     a new arraybuffer which contains all elements of this arraybuffer followed by all elements of `that`.

   Definition Classes
     TraversableLike

9. #### abstract def ++:[B](that: TraversableOnce[B]): ArrayBuffer[B]

   [use case] Concatenates this arraybuffer with the elements of a traversable collection.

   [use case]

   Concatenates this arraybuffer with the elements of a traversable collection. It differs from ++ in that the right operand determines the type of the resulting collection rather than the left one.

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new collection of type `That` which contains all elements of this arraybuffer followed by all elements of `that`.

   Definition Classes
     TraversableLike

10. #### def ++:[B >: Node, That](that: TraversableOnce[B])(implicit bf: CanBuildFrom[ArrayBuffer[Node], B, That]): That

    Concatenates this arraybuffer with the elements of a traversable collection.

    Concatenates this arraybuffer with the elements of a traversable collection. It differs from ++ in that the right operand determines the type of the resulting collection rather than the left one.

    Example:

            scala> val x = List(1)
            x: List[Int] = List(1)

            scala> val y = LinkedList(2)
            y: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

            scala> val z = x ++: y
            z: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

    B

      the element type of the returned collection.

    That

      the class of the returned collection. In the standard library configuration, `That` is always `ArrayBuffer[B]` because an implicit of type `CanBuildFrom[ArrayBuffer, B, ArrayBuffer[B]]` is defined in object `ArrayBuffer`.

    that

      the traversable to append.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`. This is usually the `canBuildFrom` value defined in object `ArrayBuffer`.

    returns

      a new collection of type `That` which contains all elements of this arraybuffer followed by all elements of `that`.

    Definition Classes
      TraversableLike

11. #### def ++=(xs: TraversableOnce[Node]): NodeBuffer.this.type

    Appends a number of elements provided by a traversable object.

    Appends a number of elements provided by a traversable object. The identity of the buffer is returned.

    xs

      the traversable object.

    returns

      the updated buffer.

    Definition Classes
      ArrayBuffer → Growable

12. #### def ++=:(xs: TraversableOnce[Node]): NodeBuffer.this.type

    Prepends a number of elements provided by a traversable object.

    Prepends a number of elements provided by a traversable object. The identity of the buffer is returned.

    xs

      the traversable object.

    returns

      the updated buffer.

    Definition Classes
      ArrayBuffer → BufferLike

13. #### abstract def +:(elem: Node): ArrayBuffer[Node]

    [use case] A copy of the arraybuffer with an element prepended.

    [use case]

    A copy of the arraybuffer with an element prepended.

    elem

      the prepended element

    returns

      a new collection of type `That` consisting of `elem` followed by all elements of this arraybuffer.

    Definition Classes
      GenSeqLike

14. #### def +:[B >: Node, That](elem: B)(implicit bf: CanBuildFrom[ArrayBuffer[Node], B, That]): That

    A copy of the arraybuffer with an element prepended.

    A copy of the arraybuffer with an element prepended.

    Note that :-ending operators are right associative (see example). Also, the original arraybuffer is not modified, so you will want to capture the result.

    Example:

             scala> val x = LinkedList(1)
             x: scala.collection.mutable.LinkedList[Int] = LinkedList(1)

             scala> val y = 2 +: x
             y: scala.collection.mutable.LinkedList[Int] = LinkedList(2, 1)

             scala> println(x)
             LinkedList(1)

    B

      the element type of the returned arraybuffer.

    That

      the class of the returned collection. In the standard library configuration, `That` is always `ArrayBuffer[B]` because an implicit of type `CanBuildFrom[ArrayBuffer, B, ArrayBuffer[B]]` is defined in object `ArrayBuffer`.

    elem

      the prepended element

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`. This is usually the `canBuildFrom` value defined in object `ArrayBuffer`.

    returns

      a new collection of type `That` consisting of `elem` followed by all elements of this arraybuffer.

    Definition Classes
      SeqLike → GenSeqLike

15. #### def +=(elem: Node): NodeBuffer.this.type

    Appends a single element to this buffer and returns the identity of the buffer.

    Appends a single element to this buffer and returns the identity of the buffer. It takes constant amortized time.

    elem

      the element to append.

    returns

      the updated buffer.

    Definition Classes
      ArrayBuffer → Builder → BufferLike → Growable

16. #### def +=(elem1: Node, elem2: Node, elems: Node*): NodeBuffer.this.type

    Appends two or more elements to this arraybuffer.

    Appends two or more elements to this arraybuffer.

    elem1

      the first element to append.

    elem2

      the second element to append.

    elems

      the remaining elements to append.

    returns

      the arraybuffer itself

    Definition Classes
      Growable

17. #### def +=:(elem: Node): NodeBuffer.this.type

    Prepends a single element to this buffer and returns the identity of the buffer.

    Prepends a single element to this buffer and returns the identity of the buffer. It takes time linear in the buffer size.

    elem

      the element to append.

    returns

      the updated buffer.

    Definition Classes
      ArrayBuffer → BufferLike

18. #### def -(elem1: Node, elem2: Node, elems: Node*): ArrayBuffer[Node]

    Creates a new collection with all the elements of this collection except the two or more specified elements.

    Creates a new collection with all the elements of this collection except the two or more specified elements.

    elem1

      the first element to remove.

    elem2

      the second element to remove.

    elems

      the remaining elements to remove.

    returns

      a new collection consisting of all the elements of this collection except `elem1`, `elem2` and those in `elems`.

    Definition Classes
      BufferLike → Subtractable
    Annotations
      @migration
    Migration

      (Changed in version 2.8.0) `-` creates a new buffer. Use `-=` to remove an element from this buffer and return that buffer itself.

19. #### def -(elem: Node): ArrayBuffer[Node]

    Creates a new collection with all the elements of this collection except `elem`.

    Creates a new collection with all the elements of this collection except `elem`.

    elem

      the element to remove.

    returns

      a new collection consisting of all the elements of this collection except `elem`.

    Definition Classes
      BufferLike → Subtractable
    Annotations
      @migration
    Migration

      (Changed in version 2.8.0) `-` creates a new buffer. Use `-=` to remove an element from this buffer and return that buffer itself.

20. #### def --(xs: GenTraversableOnce[Node]): ArrayBuffer[Node]

    Creates a new collection with all the elements of this collection except those provided by the specified traversable object.

    Creates a new collection with all the elements of this collection except those provided by the specified traversable object.

    xs

      the traversable object.

    returns

      a new collection with all the elements of this collection except those in `xs`

    Definition Classes
      BufferLike → Subtractable
    Annotations
      @migration
    Migration

      (Changed in version 2.8.0) `--` creates a new buffer. Use `--=` to remove an element from this buffer and return that buffer itself.

21. #### def --=(xs: TraversableOnce[Node]): NodeBuffer.this.type

    Removes all elements produced by an iterator from this arraybuffer.

    Removes all elements produced by an iterator from this arraybuffer.

    returns

      the arraybuffer itself

    Definition Classes
      Shrinkable

22. #### def -=(x: Node): NodeBuffer.this.type

    Removes a single element from this buffer, at its first occurrence.

    Removes a single element from this buffer, at its first occurrence. If the buffer does not contain that element, it is unchanged.

    x

      the element to remove.

    returns

      the buffer itself

    Definition Classes
      BufferLike → Shrinkable

23. #### def -=(elem1: Node, elem2: Node, elems: Node*): NodeBuffer.this.type

    Removes two or more elements from this arraybuffer.

    Removes two or more elements from this arraybuffer.

    elem1

      the first element to remove.

    elem2

      the second element to remove.

    elems

      the remaining elements to remove.

    returns

      the arraybuffer itself

    Definition Classes
      Shrinkable

24. #### def /:[B](z: B)(op: (B, Node) ⇒ B): B

    Applies a binary operator to a start value and all elements of this arraybuffer, going left to right.

    Applies a binary operator to a start value and all elements of this arraybuffer, going left to right.

    Note: `/:` is alternate syntax for `foldLeft`; `z /: xs` is the same as `xs foldLeft z`.

    Examples:

    Note that the folding function used to compute b is equivalent to that used to compute c.

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = (5 /: a)(_+_)
             b: Int = 15

             scala> val c = (5 /: a)((x,y) => x + y)
             c: Int = 15

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this arraybuffer, going left to right with the start value `z` on the left:

                      op(...op(op(z, x1), x2), ..., xn)

      where `x1, ..., xn` are the elements of this arraybuffer.

    Definition Classes
      TraversableOnce → GenTraversableOnce

25. #### def /:\[A1 >: Node](z: A1)(op: (A1, A1) ⇒ A1): A1

    A syntactic sugar for out of order folding.

    A syntactic sugar for out of order folding. See `fold`.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = (a /:\ 5)(_+_)
             b: Int = 15

    Definition Classes
      GenTraversableOnce

26. #### abstract def :+(elem: Node): ArrayBuffer[Node]

    [use case] A copy of this arraybuffer with an element appended.

    [use case]

    A copy of this arraybuffer with an element appended.

    elem

      the appended element

    returns

      a new collection of type `That` consisting of all elements of this arraybuffer followed by `elem`.

    Definition Classes
      GenSeqLike

27. #### def :+[B >: Node, That](elem: B)(implicit bf: CanBuildFrom[ArrayBuffer[Node], B, That]): That

    A copy of this arraybuffer with an element appended.

    A copy of this arraybuffer with an element appended.

    B

      the element type of the returned arraybuffer.

    That

      the class of the returned collection. In the standard library configuration, `That` is always `ArrayBuffer[B]` because an implicit of type `CanBuildFrom[ArrayBuffer, B, ArrayBuffer[B]]` is defined in object `ArrayBuffer`.

    elem

      the appended element

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`. This is usually the `canBuildFrom` value defined in object `ArrayBuffer`.

    returns

      a new collection of type `That` consisting of all elements of this arraybuffer followed by `elem`.

    Definition Classes
      SeqLike → GenSeqLike

28. #### def :\[B](z: B)(op: (Node, B) ⇒ B): B

    Applies a binary operator to all elements of this arraybuffer and a start value, going right to left.

    Applies a binary operator to all elements of this arraybuffer and a start value, going right to left.

    Note: `:\` is alternate syntax for `foldRight`; `xs :\ z` is the same as `xs foldRight z`.

    Examples:

    Note that the folding function used to compute b is equivalent to that used to compute c.

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = (a :\ 5)(_+_)
             b: Int = 15

             scala> val c = (a :\ 5)((x,y) => x + y)
             c: Int = 15

    B

      the result type of the binary operator.

    z

      the start value

    op

      the binary operator

    returns

      the result of inserting `op` between consecutive elements of this arraybuffer, going right to left with the start value `z` on the right:

                      op(x1, op(x2, ... op(xn, z)...))

      where `x1, ..., xn` are the elements of this arraybuffer.

    Definition Classes
      TraversableOnce → GenTraversableOnce

29. #### def <<(cmd: Message[Node]): Unit

    Send a message to this scriptable object.

    Send a message to this scriptable object.

    cmd

      the message to send.

    Definition Classes
      BufferLike → Scriptable

30. #### final def ==(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

31. #### final def ==(arg0: Any): Boolean

    Test two objects for equality.

    Test two objects for equality.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      Any

32. #### def addString(b: StringBuilder): StringBuilder

    Appends all elements of this arraybuffer to a string builder.

    Appends all elements of this arraybuffer to a string builder. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this arraybuffer without any separator string.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = new StringBuilder()
             b: StringBuilder =

             scala> val h = a.addString(b)
             b: StringBuilder = 1234

    b

      the string builder to which elements are appended.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

33. #### def addString(b: StringBuilder, sep: String): StringBuilder

    Appends all elements of this arraybuffer to a string builder using a separator string.

    Appends all elements of this arraybuffer to a string builder using a separator string. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this arraybuffer, separated by the string `sep`.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = new StringBuilder()
             b: StringBuilder =

             scala> a.addString(b, ", ")
             res0: StringBuilder = 1, 2, 3, 4

    b

      the string builder to which elements are appended.

    sep

      the separator string.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

34. #### def addString(b: StringBuilder, start: String, sep: String, end: String): StringBuilder

    Appends all elements of this arraybuffer to a string builder using start, end, and separator strings.

    Appends all elements of this arraybuffer to a string builder using start, end, and separator strings. The written text begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this arraybuffer are separated by the string `sep`.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = new StringBuilder()
             b: StringBuilder =

             scala> a.addString(b, "LinkedList(", ", ", ")")
             res1: StringBuilder = LinkedList(1, 2, 3, 4)

    b

      the string builder to which elements are appended.

    start

      the starting string.

    sep

      the separator string.

    end

      the ending string.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

35. #### def aggregate[B](z: B)(seqop: (B, Node) ⇒ B, combop: (B, B) ⇒ B): B

    Aggregates the results of applying an operator to subsequent elements.

    Aggregates the results of applying an operator to subsequent elements.

    This is a more general form of `fold` and `reduce`. It has similar semantics, but does not require the result to be a supertype of the element type. It traverses the elements in different partitions sequentially, using `seqop` to update the result, and then applies `combop` to results from different partitions. The implementation of this operation may operate on an arbitrary number of collection partitions, so `combop` may be invoked an arbitrary number of times.

    For example, one might want to process some elements and then produce a `Set`. In this case, `seqop` would process an element and append it to the list, while `combop` would concatenate two lists from different partitions together. The initial value `z` would be an empty set.

           pc.aggregate(Set[Int]())(_ += process(_), _ ++ _)

    Another example is calculating geometric mean from a collection of doubles (one would typically require big doubles for this).

    B

      the type of accumulated results

    z

      the initial value for the accumulated result of the partition - this will typically be the neutral element for the `seqop` operator (e.g. `Nil` for list concatenation or `0` for summation)

    seqop

      an operator used to accumulate results within a partition

    combop

      an associative operator used to combine results from different partitions

    Definition Classes
      TraversableOnce → GenTraversableOnce

36. #### def andThen[C](k: (Node) ⇒ C): PartialFunction[Int, C]

    Composes this partial function with a transformation function that gets applied to results of this partial function.

    Composes this partial function with a transformation function that gets applied to results of this partial function.

    C

      the result type of the transformation function.

    k

      the transformation function

    returns

      a partial function with the same domain as this partial function, which maps arguments `x` to `k(this(x))`.

    Definition Classes
      PartialFunction → Function1

37. #### def append(elems: Node*): Unit

    Appends the given elements to this buffer.

    Appends the given elements to this buffer.

    elems

      the elements to append.

    Definition Classes
      BufferLike

38. #### def appendAll(xs: TraversableOnce[Node]): Unit

    Appends the elements contained in a traversable object to this buffer.

    Appends the elements contained in a traversable object to this buffer.

    xs

      the traversable object containing the elements to append.

    Definition Classes
      BufferLike

39. #### def apply(idx: Int): Node

    Selects an element by its index in the arraybuffer.

    Selects an element by its index in the arraybuffer.

    Example:

           scala> val x = LinkedList(1, 2, 3, 4, 5)
           x: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4, 5)

           scala> x(3)
           res1: Int = 4

    idx

      The index to select.

    returns

      the element of this arraybuffer at index `idx`, where `0` indicates the first element.

    Definition Classes
      ResizableArray → SeqLike → GenSeqLike → Function1
    Exceptions thrown
      `IndexOutOfBoundsException`

      if `idx` does not satisfy `0 <= idx < length`.

40. #### var array: Array[AnyRef]

    Attributes
      protected
    Definition Classes
      ResizableArray

41. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown
      ClassCastException

      if the receiver object is not an instance of the erasure of type `T0`.

42. #### def canEqual(that: Any): Boolean

    Method called from equality methods, so that user-defined subclasses can refuse to be equal to other collections of the same kind.

    Method called from equality methods, so that user-defined subclasses can refuse to be equal to other collections of the same kind.

    that

      The object with which this arraybuffer should be compared

    returns

      `true`, if this arraybuffer can possibly equal `that`, `false` otherwise. The test takes into consideration only the run-time types of objects but ignores their elements.

    Definition Classes
      IterableLike → Equals

43. #### def clear(): Unit

    Clears the contents of this builder.

    Clears the contents of this builder. After execution of this method the builder will contain no elements.

    Definition Classes
      ArrayBuffer → Builder → BufferLike → Growable

44. #### def clone(): ArrayBuffer[Node]

    Return a clone of this buffer.

    Return a clone of this buffer.

    returns

      an `ArrayBuffer` with the same elements.

    Definition Classes
      ArrayBuffer → Cloneable → AnyRef

45. #### abstract def collect[B](pf: PartialFunction[Node, B]): ArrayBuffer[B]

    [use case] Builds a new collection by applying a partial function to all elements of this arraybuffer on which the function is defined.

    [use case]

    Builds a new collection by applying a partial function to all elements of this arraybuffer on which the function is defined.

    B

      the element type of the returned collection.

    pf

      the partial function which filters and maps the arraybuffer.

    returns

      a new collection of type `That` resulting from applying the partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      GenTraversableLike

46. #### def collect[B, That](pf: PartialFunction[Node, B])(implicit bf: CanBuildFrom[ArrayBuffer[Node], B, That]): That

    Builds a new collection by applying a partial function to all elements of this arraybuffer on which the function is defined.

    Builds a new collection by applying a partial function to all elements of this arraybuffer on which the function is defined.

    B

      the element type of the returned collection.

    That

      the class of the returned collection. In the standard library configuration, `That` is always `ArrayBuffer[B]` because an implicit of type `CanBuildFrom[ArrayBuffer, B, ArrayBuffer[B]]` is defined in object `ArrayBuffer`.

    pf

      the partial function which filters and maps the arraybuffer.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`. This is usually the `canBuildFrom` value defined in object `ArrayBuffer`.

    returns

      a new collection of type `That` resulting from applying the partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike

47. #### def collectFirst[B](pf: PartialFunction[Node, B]): Option[B]

    Finds the first element of the arraybuffer for which the given partial function is defined, and applies the partial function to it.

    Finds the first element of the arraybuffer for which the given partial function is defined, and applies the partial function to it.

    pf

      the partial function

    returns

      an option value containing pf applied to the first value for which it is defined, or `None` if none exists.

    Definition Classes
      TraversableOnce
    Example:

    1. `Seq("a", 1, 5L).collectFirst({ case x: Int => x*10 }) = Some(10)`

48. #### def combinations(n: Int): Iterator[ArrayBuffer[Node]]

    Iterates over combinations.

    Iterates over combinations.

    returns

      An Iterator which traverses the possible n-element combinations of this arraybuffer.

    Definition Classes
      SeqLike
    Example:

    1. `"abbbc".combinations(2) = Iterator(ab, ac, bb, bc)`

49. #### def companion: GenericCompanion[ArrayBuffer]

    The factory companion object that builds instances of class ArrayBuffer.

    The factory companion object that builds instances of class ArrayBuffer. (or its `Iterable` superclass where class ArrayBuffer is not a `Seq`.)

    Definition Classes
      ArrayBuffer → ResizableArray → IndexedSeq → IndexedSeq → Buffer → Seq → Seq → GenSeq → Iterable → Iterable → GenIterable → Traversable → Traversable → GenTraversable → GenericTraversableTemplate

50. #### def compose[A](g: (A) ⇒ Int): (A) ⇒ Node

    Composes two instances of Function1 in a new Function1, with this function applied last.

    Composes two instances of Function1 in a new Function1, with this function applied last.

    A

      the type to which function `g` can be applied

    g

      a function A => T1

    returns

      a new function `f` such that `f(x) == apply(g(x))`

    Definition Classes
      Function1

51. #### def contains(elem: Any): Boolean

    Tests whether this arraybuffer contains a given value as an element.

    Tests whether this arraybuffer contains a given value as an element.

    elem

      the element to test.

    returns

      `true` if this arraybuffer has an element that is is equal (wrt `==`) to `elem`, `false` otherwise.

    Definition Classes
      SeqLike

52. #### def containsSlice[B](that: GenSeq[B]): Boolean

    Tests whether this arraybuffer contains a given sequence as a slice.

    Tests whether this arraybuffer contains a given sequence as a slice.

    that

      the sequence to test

    returns

      `true` if this arraybuffer contains a slice with the same elements as `that`, otherwise `false`.

    Definition Classes
      SeqLike

53. #### def copy(m: Int, n: Int, len: Int): Unit

    Move parts of the array.

    Move parts of the array.

    Attributes
      protected
    Definition Classes
      ResizableArray

54. #### def copyToArray[B >: Node](xs: Array[B], start: Int, len: Int): Unit

    Fills the given array `xs` with at most `len` elements of this traversable starting at position `start`.

    Fills the given array `xs` with at most `len` elements of this traversable starting at position `start`. Copying will stop once either the end of the current traversable is reached or `len` elements have been copied or the end of the array is reached.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    start

      starting index.

    len

      number of elements to copy

    Definition Classes
      ResizableArray → IndexedSeqOptimized → IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

55. #### abstract def copyToArray(xs: Array[Node]): Unit

    [use case] Copies values of this arraybuffer to an array.

    [use case]

    Copies values of this arraybuffer to an array. Fills the given array `xs` with values of this arraybuffer. Copying will stop once either the end of the current arraybuffer is reached, or the end of the array is reached.

    xs

      the array to fill.

    Definition Classes
      GenTraversableOnce

56. #### def copyToArray[B >: Node](xs: Array[B]): Unit

    Copies values of this arraybuffer to an array.

    Copies values of this arraybuffer to an array. Fills the given array `xs` with values of this arraybuffer. Copying will stop once either the end of the current arraybuffer is reached, or the end of the array is reached.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    Definition Classes
      TraversableOnce → GenTraversableOnce

57. #### abstract def copyToArray(xs: Array[Node], start: Int): Unit

    [use case] Copies values of this arraybuffer to an array.

    [use case]

    Copies values of this arraybuffer to an array. Fills the given array `xs` with values of this arraybuffer, beginning at index `start`. Copying will stop once either the end of the current arraybuffer is reached, or the end of the array is reached.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      GenTraversableOnce

58. #### def copyToArray[B >: Node](xs: Array[B], start: Int): Unit

    Copies values of this arraybuffer to an array.

    Copies values of this arraybuffer to an array. Fills the given array `xs` with values of this arraybuffer, beginning at index `start`. Copying will stop once either the end of the current arraybuffer is reached, or the end of the array is reached.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      TraversableOnce → GenTraversableOnce

59. #### def copyToBuffer[B >: Node](dest: Buffer[B]): Unit

    Copies all elements of this arraybuffer to a buffer.

    Copies all elements of this arraybuffer to a buffer.

    dest

      The buffer to which elements are copied.

    Definition Classes
      TraversableOnce

60. #### def corresponds[B](that: GenSeq[B])(p: (Node, B) ⇒ Boolean): Boolean

    Tests whether every element of this arraybuffer relates to the corresponding element of another sequence by satisfying a test predicate.

    Tests whether every element of this arraybuffer relates to the corresponding element of another sequence by satisfying a test predicate.

    B

      the type of the elements of `that`

    that

      the other sequence

    p

      the test predicate, which relates elements from both sequences

    returns

      `true` if both sequences have the same length and `p(x, y)` is `true` for all corresponding elements `x` of this arraybuffer and `y` of `that`, otherwise `false`.

    Definition Classes
      SeqLike → GenSeqLike

61. #### def count(p: (Node) ⇒ Boolean): Int

    Counts the number of elements in the arraybuffer which satisfy a predicate.

    Counts the number of elements in the arraybuffer which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      the number of elements satisfying the predicate `p`.

    Definition Classes
      TraversableOnce → GenTraversableOnce

62. #### abstract def diff(that: Seq[Node]): ArrayBuffer[Node]

    [use case] Computes the multiset difference between this arraybuffer and another sequence.

    [use case]

    Computes the multiset difference between this arraybuffer and another sequence.

    that

      the sequence of elements to remove

    returns

      a new collection of type `That` which contains all elements of this arraybuffer except some of occurrences of elements that also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will not form part of the result, but any following occurrences will.

    Definition Classes
      SeqLike

63. #### def diff[B >: Node](that: GenSeq[B]): ArrayBuffer[Node]

    Computes the multiset difference between this arraybuffer and another sequence.

    Computes the multiset difference between this arraybuffer and another sequence.

    B

      the element type of the returned arraybuffer.

    that

      the sequence of elements to remove

    returns

      a new collection of type `That` which contains all elements of this arraybuffer except some of occurrences of elements that also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will not form part of the result, but any following occurrences will.

    Definition Classes
      SeqLike → GenSeqLike

64. #### def distinct: ArrayBuffer[Node]

    Builds a new arraybuffer from this arraybuffer without any duplicate elements.

    Builds a new arraybuffer from this arraybuffer without any duplicate elements.

    returns

      A new arraybuffer which contains the first occurrence of every element of this arraybuffer.

    Definition Classes
      SeqLike → GenSeqLike

65. #### def drop(n: Int): ArrayBuffer[Node]

    Selects all elements except first n ones.

    Selects all elements except first n ones.

    n

      the number of elements to drop from this arraybuffer.

    returns

      a arraybuffer consisting of all elements of this arraybuffer except the first `n` ones, or else the empty arraybuffer, if this arraybuffer has less than `n` elements.

    Definition Classes
      IndexedSeqOptimized → IterableLike → TraversableLike → GenTraversableLike

66. #### def dropRight(n: Int): ArrayBuffer[Node]

    Selects all elements except last n ones.

    Selects all elements except last n ones.

    n

      The number of elements to take

    returns

      a arraybuffer consisting of all elements of this arraybuffer except the last `n` ones, or else the empty arraybuffer, if this arraybuffer has less than `n` elements.

    Definition Classes
      IndexedSeqOptimized → IterableLike

67. #### def dropWhile(p: (Node) ⇒ Boolean): ArrayBuffer[Node]

    Drops longest prefix of elements that satisfy a predicate.

    Drops longest prefix of elements that satisfy a predicate.

    p

      The predicate used to test elements.

    returns

      the longest suffix of this arraybuffer whose first element does not satisfy the predicate `p`.

    Definition Classes
      IndexedSeqOptimized → TraversableLike → GenTraversableLike

68. #### def endsWith[B](that: GenSeq[B]): Boolean

    Tests whether this arraybuffer ends with the given sequence.

    Tests whether this arraybuffer ends with the given sequence.

    that

      the sequence to test

    returns

      `true` if this arraybuffer has `that` as a suffix, `false` otherwise.

    Definition Classes
      IndexedSeqOptimized → SeqLike → GenSeqLike

69. #### def ensureSize(n: Int): Unit

    ensure that the internal array has at n cells

    ensure that the internal array has at n cells

    Attributes
      protected
    Definition Classes
      ResizableArray

70. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

71. #### def equals(that: Any): Boolean

    The equals method for arbitrary sequences.

    The equals method for arbitrary sequences. Compares this sequence to some other object.

    that

      The object to compare the sequence to

    returns

      `true` if `that` is a sequence that has the same elements as this sequence in the same order, `false` otherwise

    Definition Classes
      GenSeqLike → Equals → AnyRef → Any

72. #### def exists(p: (Node) ⇒ Boolean): Boolean

    Tests whether a predicate holds for some of the elements of this arraybuffer.

    Tests whether a predicate holds for some of the elements of this arraybuffer.

    p

      the predicate used to test elements.

    returns

      `true` if the given predicate `p` holds for some of the elements of this arraybuffer, otherwise `false`.

    Definition Classes
      IndexedSeqOptimized → IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

73. #### def filter(p: (Node) ⇒ Boolean): ArrayBuffer[Node]

    Selects all elements of this arraybuffer which satisfy a predicate.

    Selects all elements of this arraybuffer which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      a new arraybuffer consisting of all elements of this arraybuffer that satisfy the given predicate `p`. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike

74. #### def filterNot(p: (Node) ⇒ Boolean): ArrayBuffer[Node]

    Selects all elements of this arraybuffer which do not satisfy a predicate.

    Selects all elements of this arraybuffer which do not satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      a new arraybuffer consisting of all elements of this arraybuffer that do not satisfy the given predicate `p`. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike

75. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

76. #### def find(p: (Node) ⇒ Boolean): Option[Node]

    Finds the first element of the arraybuffer satisfying a predicate, if any.

    Finds the first element of the arraybuffer satisfying a predicate, if any.

    p

      the predicate used to test elements.

    returns

      an option value containing the first element in the arraybuffer that satisfies `p`, or `None` if none exists.

    Definition Classes
      IndexedSeqOptimized → IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

77. #### abstract def flatMap[B](f: (Node) ⇒ GenTraversableOnce[B]): ArrayBuffer[B]

    [use case] Builds a new collection by applying a function to all elements of this arraybuffer and using the elements of the resulting collections.

    [use case]

    Builds a new collection by applying a function to all elements of this arraybuffer and using the elements of the resulting collections. For example:

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new collection of type `That` resulting from applying the given collection-valued function `f` to each element of this arraybuffer and concatenating the results.

    Definition Classes
      GenTraversableLike

78. #### def flatMap[B, That](f: (Node) ⇒ GenTraversableOnce[B])(implicit bf: CanBuildFrom[ArrayBuffer[Node], B, That]): That

    Builds a new collection by applying a function to all elements of this arraybuffer and using the elements of the resulting collections.

    Builds a new collection by applying a function to all elements of this arraybuffer and using the elements of the resulting collections. For example:

         def getWords(lines: Seq[String]): Seq[String] = lines flatMap (line => line split "\\W+")

    The type of the resulting collection is guided by the static type of arraybuffer. This might cause unexpected results sometimes. For example:

         // lettersOf will return a Seq[Char] of likely repeated letters, instead of a Set
         def lettersOf(words: Seq[String]) = words flatMap (word => word.toSet)

         // lettersOf will return a Set[Char], not a Seq
         def lettersOf(words: Seq[String]) = words.toSet flatMap (word => word.toSeq)

         // xs will be a an Iterable[Int]
         val xs = Map("a" -> List(11,111), "b" -> List(22,222)).flatMap(_._2)

         // ys will be a Map[Int, Int]
         val ys = Map("a" -> List(1 -> 11,1 -> 111), "b" -> List(2 -> 22,2 -> 222)).flatMap(_._2)

    B

      the element type of the returned collection.

    That

      the class of the returned collection. In the standard library configuration, `That` is always `ArrayBuffer[B]` because an implicit of type `CanBuildFrom[ArrayBuffer, B, ArrayBuffer[B]]` is defined in object `ArrayBuffer`.

    f

      the function to apply to each element.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`. This is usually the `canBuildFrom` value defined in object `ArrayBuffer`.

    returns

      a new collection of type `That` resulting from applying the given collection-valued function `f` to each element of this arraybuffer and concatenating the results.

    Definition Classes
      TraversableLike → GenTraversableLike → FilterMonadic

79. #### abstract def flatten[B]: ArrayBuffer[B]

    [use case] Converts this arraybuffer of traversable collections into a arraybuffer formed by the elements of these traversable collections.

    [use case]

    Converts this arraybuffer of traversable collections into a arraybuffer formed by the elements of these traversable collections.

    B

      the type of the elements of each traversable collection.

    returns

      a new arraybuffer resulting from concatenating all element arraybuffers.

    Definition Classes
      GenericTraversableTemplate

80. #### def fold[A1 >: Node](z: A1)(op: (A1, A1) ⇒ A1): A1

    Folds the elements of this arraybuffer using the specified associative binary operator.

    Folds the elements of this arraybuffer using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      a type parameter for the binary operator, a supertype of `A`.

    z

      a neutral element for the fold operation; may be added to the result an arbitrary number of times, and must not change the result (e.g., `Nil` for list concatenation, 0 for addition, or 1 for multiplication.)

    op

      a binary operator that must be associative

    returns

      the result of applying fold operator `op` between all the elements and `z`

    Definition Classes
      TraversableOnce → GenTraversableOnce

81. #### def foldLeft[B](z: B)(op: (B, Node) ⇒ B): B

    Applies a binary operator to a start value and all elements of this arraybuffer, going left to right.

    Applies a binary operator to a start value and all elements of this arraybuffer, going left to right.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this arraybuffer, going left to right with the start value `z` on the left:

                      op(...op(z, x1), x2, ..., xn)

      where `x1, ..., xn` are the elements of this arraybuffer.

    Definition Classes
      IndexedSeqOptimized → TraversableOnce → GenTraversableOnce

82. #### def foldRight[B](z: B)(op: (Node, B) ⇒ B): B

    Applies a binary operator to all elements of this arraybuffer and a start value, going right to left.

    Applies a binary operator to all elements of this arraybuffer and a start value, going right to left.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this arraybuffer, going right to left with the start value `z` on the right:

                      op(x1, op(x2, ... op(xn, z)...))

      where `x1, ..., xn` are the elements of this arraybuffer.

    Definition Classes
      IndexedSeqOptimized → IterableLike → TraversableOnce → GenTraversableOnce

83. #### def forall(p: (Node) ⇒ Boolean): Boolean

    Tests whether a predicate holds for all elements of this arraybuffer.

    Tests whether a predicate holds for all elements of this arraybuffer.

    p

      the predicate used to test elements.

    returns

      `true` if the given predicate `p` holds for all elements of this arraybuffer, otherwise `false`.

    Definition Classes
      IndexedSeqOptimized → IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

84. #### abstract def foreach(f: (Node) ⇒ Unit): Unit

    [use case] Applies a function `f` to all elements of this arraybuffer.

    [use case]

    Applies a function `f` to all elements of this arraybuffer.

    f

      the function that is applied for its side-effect to every element. The result of function `f` is discarded.

    Definition Classes
      IterableLike

85. #### def foreach[U](f: (Node) ⇒ U): Unit

    Applies a function `f` to all elements of this arraybuffer.

    Applies a function `f` to all elements of this arraybuffer.

    Note: this method underlies the implementation of most other bulk operations. Subclasses should re-implement this method if a more efficient implementation exists.

    U

      the type parameter describing the result of function `f`. This result will always be ignored. Typically `U` is `Unit`, but this is not necessary.

    f

      the function that is applied for its side-effect to every element. The result of function `f` is discarded.

    Definition Classes
      ResizableArray → IndexedSeqOptimized → IterableLike → GenericTraversableTemplate → TraversableLike → GenTraversableLike → TraversableOnce → GenTraversableOnce → FilterMonadic

86. #### def genericBuilder[B]: Builder[B, ArrayBuffer[B]]

    The generic builder that builds instances of ArrayBuffer at arbitrary element types.

    The generic builder that builds instances of ArrayBuffer at arbitrary element types.

    Definition Classes
      GenericTraversableTemplate

87. #### final def getClass(): java.lang.Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

88. #### def groupBy[K](f: (Node) ⇒ K): Map[K, ArrayBuffer[Node]]

    Partitions this arraybuffer into a map of arraybuffers according to some discriminator function.

    Partitions this arraybuffer into a map of arraybuffers according to some discriminator function.

    Note: this method is not re-implemented by views. This means when applied to a view it will always force the view and return a new arraybuffer.

    K

      the type of keys returned by the discriminator function.

    f

      the discriminator function.

    returns

      A map from keys to arraybuffers such that the following invariant holds:

                          (xs partition f)(k) = xs filter (x => f(x) == k)

      That is, every key `k` is bound to a arraybuffer of those elements `x` for which `f(x)` equals `k`.

    Definition Classes
      TraversableLike → GenTraversableLike

89. #### def grouped(size: Int): Iterator[ArrayBuffer[Node]]

    Partitions elements in fixed size arraybuffers.

    Partitions elements in fixed size arraybuffers.

    size

      the number of elements per group

    returns

      An iterator producing arraybuffers of size `size`, except the last will be truncated if the elements don't divide evenly.

    Definition Classes
      IterableLike
    See also

      Iterator#grouped

90. #### def hasDefiniteSize: Boolean

    Tests whether this arraybuffer is known to have a finite size.

    Tests whether this arraybuffer is known to have a finite size. All strict collections are known to have finite size. For a non-strict collection such as `Stream`, the predicate returns `true` if all elements have been computed. It returns `false` if the stream is not yet evaluated to the end.

    Note: many collection methods will not work on collections of infinite sizes.

    returns

      `true` if this collection is known to have finite size, `false` otherwise.

    Definition Classes
      TraversableLike → TraversableOnce → GenTraversableOnce

91. #### def hashCode(): Int

    Hashcodes for ArrayBuffer produce a value from the hashcodes of all the elements of the arraybuffer.

    Hashcodes for ArrayBuffer produce a value from the hashcodes of all the elements of the arraybuffer.

    returns

      the hash code value for this object.

    Definition Classes
      GenSeqLike → AnyRef → Any

92. #### def head: Node

    Selects the first element of this arraybuffer.

    Selects the first element of this arraybuffer.

    returns

      the first element of this arraybuffer.

    Definition Classes
      IndexedSeqOptimized → IterableLike → GenIterableLike → TraversableLike → GenTraversableLike
    Exceptions thrown
      `NoSuchElementException`

      if the arraybuffer is empty.

93. #### def headOption: Option[Node]

    Optionally selects the first element.

    Optionally selects the first element.

    returns

      the first element of this arraybuffer if it is nonempty, `None` if it is empty.

    Definition Classes
      TraversableLike

94. #### abstract def indexOf(elem: Node, from: Int): Int

    [use case] Finds index of first occurrence of some value in this arraybuffer after or at some start index.

    [use case]

    Finds index of first occurrence of some value in this arraybuffer after or at some start index.

    elem

      the element value to search for.

    from

      the start index

    returns

      the index `>= from` of the first element of this arraybuffer that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

95. #### def indexOf[B >: Node](elem: B, from: Int): Int

    Finds index of first occurrence of some value in this arraybuffer after or at some start index.

    Finds index of first occurrence of some value in this arraybuffer after or at some start index.

    B

      the type of the element `elem`.

    elem

      the element value to search for.

    from

      the start index

    returns

      the index `>= from` of the first element of this arraybuffer that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

96. #### abstract def indexOf(elem: Node): Int

    [use case] Finds index of first occurrence of some value in this arraybuffer.

    [use case]

    Finds index of first occurrence of some value in this arraybuffer.

    elem

      the element value to search for.

    returns

      the index of the first element of this arraybuffer that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

97. #### def indexOf[B >: Node](elem: B): Int

    Finds index of first occurrence of some value in this arraybuffer.

    Finds index of first occurrence of some value in this arraybuffer.

    B

      the type of the element `elem`.

    elem

      the element value to search for.

    returns

      the index of the first element of this arraybuffer that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

98. #### def indexOfSlice[B >: Node](that: GenSeq[B], from: Int): Int

    Finds first index after or at a start index where this arraybuffer contains a given sequence as a slice.

    Finds first index after or at a start index where this arraybuffer contains a given sequence as a slice.

    that

      the sequence to test

    from

      the start index

    returns

      the first index `>= from` such that the elements of this arraybuffer starting at this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

    Definition Classes
      SeqLike

99. #### def indexOfSlice[B >: Node](that: GenSeq[B]): Int

    Finds first index where this arraybuffer contains a given sequence as a slice.

    Finds first index where this arraybuffer contains a given sequence as a slice.

    that

      the sequence to test

    returns

      the first index such that the elements of this arraybuffer starting at this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

    Definition Classes
      SeqLike

100. #### def indexWhere(p: (Node) ⇒ Boolean, from: Int): Int

     Finds index of the first element satisfying some predicate after or at some start index.

     Finds index of the first element satisfying some predicate after or at some start index.

     p

       the predicate used to test elements.

     from

       the start index

     returns

       the index `>= from` of the first element of this arraybuffer that satisfies the predicate `p`, or `-1`, if none exists.

     Definition Classes
       IndexedSeqOptimized → SeqLike → GenSeqLike

101. #### def indexWhere(p: (Node) ⇒ Boolean): Int

     Finds index of first element satisfying some predicate.

     Finds index of first element satisfying some predicate.

     p

       the predicate used to test elements.

     returns

       the index of the first element of this arraybuffer that satisfies the predicate `p`, or `-1`, if none exists.

     Definition Classes
       GenSeqLike

102. #### def indices: Range

     Produces the range of all indices of this sequence.

     Produces the range of all indices of this sequence.

     returns

       a `Range` value from `0` to one less than the length of this arraybuffer.

     Definition Classes
       SeqLike

103. #### def init: ArrayBuffer[Node]

     Selects all elements except the last.

     Selects all elements except the last.

     returns

       a arraybuffer consisting of all elements of this arraybuffer except the last one.

     Definition Classes
       IndexedSeqOptimized → TraversableLike
     Exceptions thrown
       `UnsupportedOperationException`

       if the arraybuffer is empty.

104. #### val initialSize: Int

     Attributes
       protected
     Definition Classes
       ArrayBuffer → ResizableArray

105. #### def inits: Iterator[ArrayBuffer[Node]]

     Iterates over the inits of this arraybuffer.

     Iterates over the inits of this arraybuffer. The first value will be this arraybuffer and the final one will be an empty arraybuffer, with the intervening values the results of successive applications of `init`.

     returns

       an iterator over all the inits of this arraybuffer

     Definition Classes
       TraversableLike
     Example:

     1. `List(1,2,3).inits = Iterator(List(1,2,3), List(1,2), List(1), Nil)`

106. #### def insert(n: Int, elems: Node*): Unit

     Inserts new elements at a given index into this buffer.

     Inserts new elements at a given index into this buffer.

     n

       the index where new elements are inserted.

     elems

       the traversable collection containing the elements to insert.

     Definition Classes
       BufferLike
     Exceptions thrown
       IndexOutOfBoundsException

       if the index `n` is not in the valid range `0 <= n <= length`.

107. #### def insertAll(n: Int, seq: Traversable[Node]): Unit

     Inserts new elements at the index `n`.

     Inserts new elements at the index `n`. Opposed to method `update`, this method will not replace an element with a one. Instead, it will insert a new element at index `n`.

     n

       the index where a new element will be inserted.

     seq

       the traversable object providing all elements to insert.

     Definition Classes
       ArrayBuffer → BufferLike
     Exceptions thrown
       Predef.IndexOutOfBoundsException

       if `n` is out of bounds.

108. #### abstract def intersect(that: Seq[Node]): ArrayBuffer[Node]

     [use case] Computes the multiset intersection between this arraybuffer and another sequence.

     [use case]

     Computes the multiset intersection between this arraybuffer and another sequence.

     that

       the sequence of elements to intersect with.

     returns

       a new collection of type `That` which contains all elements of this arraybuffer which also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will be retained in the result, but any following occurrences will be omitted.

     Definition Classes
       SeqLike

109. #### def intersect[B >: Node](that: GenSeq[B]): ArrayBuffer[Node]

     Computes the multiset intersection between this arraybuffer and another sequence.

     Computes the multiset intersection between this arraybuffer and another sequence.

     B

       the element type of the returned arraybuffer.

     that

       the sequence of elements to intersect with.

     returns

       a new collection of type `That` which contains all elements of this arraybuffer which also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will be retained in the result, but any following occurrences will be omitted.

     Definition Classes
       SeqLike → GenSeqLike

110. #### def isDefinedAt(idx: Int): Boolean

     Tests whether this arraybuffer contains given index.

     Tests whether this arraybuffer contains given index.

     The implementations of methods `apply` and `isDefinedAt` turn a `Seq[A]` into a `PartialFunction[Int, A]`.

     idx

       the index to test

     returns

       `true` if this arraybuffer contains an element at position `idx`, `false` otherwise.

     Definition Classes
       GenSeqLike

111. #### def isEmpty: Boolean

     Tests whether the arraybuffer is empty.

     Tests whether the arraybuffer is empty.

     returns

       `true` if the arraybuffer contains no elements, `false` otherwise.

     Definition Classes
       IndexedSeqOptimized → IterableLike → GenIterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

112. #### final def isInstanceOf[T0]: Boolean

     Test whether the dynamic type of the receiver object is `T0`.

     Test whether the dynamic type of the receiver object is `T0`.

     Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

     returns

       `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

     Definition Classes
       Any

113. #### final def isTraversableAgain: Boolean

     Tests whether this arraybuffer can be repeatedly traversed.

     Tests whether this arraybuffer can be repeatedly traversed.

     returns

       `true`

     Definition Classes
       GenTraversableLike → GenTraversableOnce

114. #### def iterator: Iterator[Node]

     Creates a new iterator over all elements contained in this iterable object.

     Creates a new iterator over all elements contained in this iterable object.

     returns

       the new iterator

     Definition Classes
       IndexedSeqLike → IterableLike → GenIterableLike

115. #### def last: Node

     Selects the last element.

     Selects the last element.

     returns

       The last element of this arraybuffer.

     Definition Classes
       IndexedSeqOptimized → TraversableLike
     Exceptions thrown
       NoSuchElementException

       If the arraybuffer is empty.

116. #### abstract def lastIndexOf(elem: Node, end: Int): Int

     [use case] Finds index of last occurrence of some value in this arraybuffer before or at a given end index.

     [use case]

     Finds index of last occurrence of some value in this arraybuffer before or at a given end index.

     elem

       the element value to search for.

     end

       the end index.

     returns

       the index `<= end` of the last element of this arraybuffer that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

     Definition Classes
       GenSeqLike

117. #### def lastIndexOf[B >: Node](elem: B, end: Int): Int

     Finds index of last occurrence of some value in this arraybuffer before or at a given end index.

     Finds index of last occurrence of some value in this arraybuffer before or at a given end index.

     B

       the type of the element `elem`.

     elem

       the element value to search for.

     end

       the end index.

     returns

       the index `<= end` of the last element of this arraybuffer that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

     Definition Classes
       GenSeqLike

118. #### abstract def lastIndexOf(elem: Node): Int

     [use case] Finds index of last occurrence of some value in this arraybuffer.

     [use case]

     Finds index of last occurrence of some value in this arraybuffer.

     elem

       the element value to search for.

     returns

       the index of the last element of this arraybuffer that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

     Definition Classes
       GenSeqLike

119. #### def lastIndexOf[B >: Node](elem: B): Int

     Finds index of last occurrence of some value in this arraybuffer.

     Finds index of last occurrence of some value in this arraybuffer.

     B

       the type of the element `elem`.

     elem

       the element value to search for.

     returns

       the index of the last element of this arraybuffer that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

     Definition Classes
       GenSeqLike

120. #### def lastIndexOfSlice[B >: Node](that: GenSeq[B], end: Int): Int

     Finds last index before or at a given end index where this arraybuffer contains a given sequence as a slice.

     Finds last index before or at a given end index where this arraybuffer contains a given sequence as a slice.

     that

       the sequence to test

     end

       the end index

     returns

       the last index `<= end` such that the elements of this arraybuffer starting at this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

     Definition Classes
       SeqLike

121. #### def lastIndexOfSlice[B >: Node](that: GenSeq[B]): Int

     Finds last index where this arraybuffer contains a given sequence as a slice.

     Finds last index where this arraybuffer contains a given sequence as a slice.

     that

       the sequence to test

     returns

       the last index such that the elements of this arraybuffer starting a this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

     Definition Classes
       SeqLike

122. #### def lastIndexWhere(p: (Node) ⇒ Boolean, end: Int): Int

     Finds index of last element satisfying some predicate before or at given end index.

     Finds index of last element satisfying some predicate before or at given end index.

     p

       the predicate used to test elements.

     returns

       the index `<= end` of the last element of this arraybuffer that satisfies the predicate `p`, or `-1`, if none exists.

     Definition Classes
       IndexedSeqOptimized → SeqLike → GenSeqLike

123. #### def lastIndexWhere(p: (Node) ⇒ Boolean): Int

     Finds index of last element satisfying some predicate.

     Finds index of last element satisfying some predicate.

     p

       the predicate used to test elements.

     returns

       the index of the last element of this arraybuffer that satisfies the predicate `p`, or `-1`, if none exists.

     Definition Classes
       GenSeqLike

124. #### def lastOption: Option[Node]

     Optionally selects the last element.

     Optionally selects the last element.

     returns

       the last element of this arraybuffer$ if it is nonempty, `None` if it is empty.

     Definition Classes
       TraversableLike

125. #### def length: Int

     Returns the length of this resizable array.

     Returns the length of this resizable array.

     returns

       the number of elements in this arraybuffer.

     Definition Classes
       ResizableArray → SeqLike → GenSeqLike

126. #### def lengthCompare(len: Int): Int

     Compares the length of this arraybuffer to a test value.

     Compares the length of this arraybuffer to a test value.

     len

       the test value that gets compared with the length.

     returns

       A value `x` where

                  x <  0       if this.length <  len
                  x == 0       if this.length == len
                  x >  0       if this.length >  len

       The method as implemented here does not call `length` directly; its running time is `O(length min len)` instead of `O(length)`. The method should be overwritten if computing `length` is cheap.

     Definition Classes
       IndexedSeqOptimized → SeqLike

127. #### def lift: (Int) ⇒ Option[Node]

     Turns this partial function into an plain function returning an `Option` result.

     Turns this partial function into an plain function returning an `Option` result.

     returns

       a function that takes an argument `x` to `Some(this(x))` if `this` is defined for `x`, and to `None` otherwise.

     Definition Classes
       PartialFunction
     See also

       Function.unlift

128. #### abstract def map[B](f: (Node) ⇒ B): ArrayBuffer[B]

     [use case] Builds a new collection by applying a function to all elements of this arraybuffer.

     [use case]

     Builds a new collection by applying a function to all elements of this arraybuffer.

     B

       the element type of the returned collection.

     f

       the function to apply to each element.

     returns

       a new collection of type `That` resulting from applying the given function `f` to each element of this arraybuffer and collecting the results.

     Definition Classes
       GenTraversableLike

129. #### def map[B, That](f: (Node) ⇒ B)(implicit bf: CanBuildFrom[ArrayBuffer[Node], B, That]): That

     Builds a new collection by applying a function to all elements of this arraybuffer.

     Builds a new collection by applying a function to all elements of this arraybuffer.

     B

       the element type of the returned collection.

     That

       the class of the returned collection. In the standard library configuration, `That` is always `ArrayBuffer[B]` because an implicit of type `CanBuildFrom[ArrayBuffer, B, ArrayBuffer[B]]` is defined in object `ArrayBuffer`.

     f

       the function to apply to each element.

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`. This is usually the `canBuildFrom` value defined in object `ArrayBuffer`.

     returns

       a new collection of type `That` resulting from applying the given function `f` to each element of this arraybuffer and collecting the results.

     Definition Classes
       TraversableLike → GenTraversableLike → FilterMonadic

130. #### def mapResult[NewTo](f: (ArrayBuffer[Node]) ⇒ NewTo): Builder[Node, NewTo]

     Creates a new builder by applying a transformation function to the results of this builder.

     Creates a new builder by applying a transformation function to the results of this builder.

     NewTo

       the type of collection returned by `f`.

     f

       the transformation function.

     returns

       a new builder which is the same as the current builder except that a transformation function is applied to this builder's result.

     Definition Classes
       Builder

131. #### abstract def max: Node

     [use case] Finds the largest element.

     [use case]

     Finds the largest element.

     returns

       the largest element of this arraybuffer with respect to the ordering `cmp`.

     Definition Classes
       GenTraversableOnce

132. #### def max[B >: Node](implicit cmp: Ordering[B]): Node

     Finds the largest element.

     Finds the largest element.

     B

       The type over which the ordering is defined.

     cmp

       An ordering to be used for comparing elements.

     returns

       the largest element of this arraybuffer with respect to the ordering `cmp`.

     Definition Classes
       TraversableOnce → GenTraversableOnce

133. #### def maxBy[B](f: (Node) ⇒ B)(implicit cmp: Ordering[B]): Node

     Definition Classes
       TraversableOnce → GenTraversableOnce

134. #### abstract def min: Node

     [use case] Finds the smallest element.

     [use case]

     Finds the smallest element.

     returns

       the smallest element of this arraybuffer with respect to the ordering `cmp`.

     Definition Classes
       GenTraversableOnce

135. #### def min[B >: Node](implicit cmp: Ordering[B]): Node

     Finds the smallest element.

     Finds the smallest element.

     B

       The type over which the ordering is defined.

     cmp

       An ordering to be used for comparing elements.

     returns

       the smallest element of this arraybuffer with respect to the ordering `cmp`.

     Definition Classes
       TraversableOnce → GenTraversableOnce

136. #### def minBy[B](f: (Node) ⇒ B)(implicit cmp: Ordering[B]): Node

     Definition Classes
       TraversableOnce → GenTraversableOnce

137. #### def mkString: String

     Displays all elements of this arraybuffer in a string.

     Displays all elements of this arraybuffer in a string.

     returns

       a string representation of this arraybuffer. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this arraybuffer follow each other without any separator string.

     Definition Classes
       TraversableOnce → GenTraversableOnce

138. #### def mkString(sep: String): String

     Displays all elements of this arraybuffer in a string using a separator string.

     Displays all elements of this arraybuffer in a string using a separator string.

     sep

       the separator string.

     returns

       a string representation of this arraybuffer. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this arraybuffer are separated by the string `sep`.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Example:

     1. `List(1, 2, 3).mkString("|") = "1|2|3"`

139. #### def mkString(start: String, sep: String, end: String): String

     Displays all elements of this arraybuffer in a string using start, end, and separator strings.

     Displays all elements of this arraybuffer in a string using start, end, and separator strings.

     start

       the starting string.

     sep

       the separator string.

     end

       the ending string.

     returns

       a string representation of this arraybuffer. The resulting string begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this arraybuffer are separated by the string `sep`.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Example:

     1. `List(1, 2, 3).mkString("(", "; ", ")") = "(1; 2; 3)"`

140. #### final def ne(arg0: AnyRef): Boolean

     Equivalent to `!(this eq that)`.

     Equivalent to `!(this eq that)`.

     returns

       `true` if the argument is not a reference to the receiver object; `false` otherwise.

     Definition Classes
       AnyRef

141. #### def newBuilder: Builder[Node, ArrayBuffer[Node]]

     The builder that builds instances of type ArrayBuffer[A]

     The builder that builds instances of type ArrayBuffer[A]

     Attributes
       protected[this]
     Definition Classes
       GenericTraversableTemplate → HasNewBuilder

142. #### def nonEmpty: Boolean

     Tests whether the arraybuffer is not empty.

     Tests whether the arraybuffer is not empty.

     returns

       `true` if the arraybuffer contains at least one element, `false` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

143. #### final def notify(): Unit

     Wakes up a single thread that is waiting on the receiver object's monitor.

     Wakes up a single thread that is waiting on the receiver object's monitor.

     Definition Classes
       AnyRef
     Note

       not specified by SLS as a member of AnyRef

144. #### final def notifyAll(): Unit

     Wakes up all threads that are waiting on the receiver object's monitor.

     Wakes up all threads that are waiting on the receiver object's monitor.

     Definition Classes
       AnyRef
     Note

       not specified by SLS as a member of AnyRef

145. #### def orElse[A1 <: Int, B1 >: Node](that: PartialFunction[A1, B1]): PartialFunction[A1, B1]

     Composes this partial function with a fallback partial function which gets applied where this partial function is not defined.

     Composes this partial function with a fallback partial function which gets applied where this partial function is not defined.

     A1

       the argument type of the fallback function

     B1

       the result type of the fallback function

     that

       the fallback function

     returns

       a partial function which has as domain the union of the domains of this partial function and `that`. The resulting partial function takes `x` to `this(x)` where `this` is defined, and to `that(x)` where it is not.

     Definition Classes
       PartialFunction

146. #### abstract def padTo(len: Int, elem: Node): ArrayBuffer[Node]

     [use case] A copy of this arraybuffer with an element value appended until a given target length is reached.

     [use case]

     A copy of this arraybuffer with an element value appended until a given target length is reached.

     len

       the target length

     elem

       the padding value

     returns

       a new collection of type `That` consisting of all elements of this arraybuffer followed by the minimal number of occurrences of `elem` so that the resulting collection has a length of at least `len`.

     Definition Classes
       GenSeqLike

147. #### def padTo[B >: Node, That](len: Int, elem: B)(implicit bf: CanBuildFrom[ArrayBuffer[Node], B, That]): That

     A copy of this arraybuffer with an element value appended until a given target length is reached.

     A copy of this arraybuffer with an element value appended until a given target length is reached.

     B

       the element type of the returned arraybuffer.

     That

       the class of the returned collection. In the standard library configuration, `That` is always `ArrayBuffer[B]` because an implicit of type `CanBuildFrom[ArrayBuffer, B, ArrayBuffer[B]]` is defined in object `ArrayBuffer`.

     len

       the target length

     elem

       the padding value

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`. This is usually the `canBuildFrom` value defined in object `ArrayBuffer`.

     returns

       a new collection of type `That` consisting of all elements of this arraybuffer followed by the minimal number of occurrences of `elem` so that the resulting collection has a length of at least `len`.

     Definition Classes
       SeqLike → GenSeqLike

148. #### def par: ParArray[Node]

     Returns a parallel implementation of this collection.

     Returns a parallel implementation of this collection.

     For most collection types, this method creates a new parallel collection by copying all the elements. For these collection, `par` takes linear time. Mutable collections in this category do not produce a mutable parallel collection that has the same underlying dataset, so changes in one collection will not be reflected in the other one.

     Specific collections (e.g. `ParArray` or `mutable.ParHashMap`) override this default behaviour by creating a parallel collection which shares the same underlying dataset. For these collections, `par` takes constant or sublinear time.

     All parallel collections return a reference to themselves.

     returns

       a parallel implementation of this collection

     Definition Classes
       ArrayBuffer → CustomParallelizable → Parallelizable

149. #### def parCombiner: Combiner[Node, ParArray[Node]]

     The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

     The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

     returns

       a combiner for the parallel collection of type `ParRepr`

     Attributes
       protected[this]
     Definition Classes
       CustomParallelizable → Parallelizable

150. #### def partition(p: (Node) ⇒ Boolean): (ArrayBuffer[Node], ArrayBuffer[Node])

     Partitions this arraybuffer in two arraybuffers according to a predicate.

     Partitions this arraybuffer in two arraybuffers according to a predicate.

     p

       the predicate on which to partition.

     returns

       a pair of arraybuffers: the first arraybuffer consists of all elements that satisfy the predicate `p` and the second arraybuffer consists of all elements that don't. The relative order of the elements in the resulting arraybuffers is the same as in the original arraybuffer.

     Definition Classes
       TraversableLike → GenTraversableLike

151. #### abstract def patch(from: Int, that: GenSeq[Node], replaced: Int): ArrayBuffer[Node]

     [use case] Produces a new arraybuffer where a slice of elements in this arraybuffer is replaced by another sequence.

     [use case]

     Produces a new arraybuffer where a slice of elements in this arraybuffer is replaced by another sequence.

     from

       the index of the first replaced element

     replaced

       the number of elements to drop in the original arraybuffer

     returns

       a new arraybuffer consisting of all elements of this arraybuffer except that `replaced` elements starting from `from` are replaced by `patch`.

     Definition Classes
       GenSeqLike

152. #### def patch[B >: Node, That](from: Int, patch: GenSeq[B], replaced: Int)(implicit bf: CanBuildFrom[ArrayBuffer[Node], B, That]): That

     Produces a new arraybuffer where a slice of elements in this arraybuffer is replaced by another sequence.

     Produces a new arraybuffer where a slice of elements in this arraybuffer is replaced by another sequence.

     B

       the element type of the returned arraybuffer.

     That

       the class of the returned collection. In the standard library configuration, `That` is always `ArrayBuffer[B]` because an implicit of type `CanBuildFrom[ArrayBuffer, B, ArrayBuffer[B]]` is defined in object `ArrayBuffer`.

     from

       the index of the first replaced element

     patch

       the replacement sequence

     replaced

       the number of elements to drop in the original arraybuffer

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`. This is usually the `canBuildFrom` value defined in object `ArrayBuffer`.

     returns

       a new arraybuffer consisting of all elements of this arraybuffer except that `replaced` elements starting from `from` are replaced by `patch`.

     Definition Classes
       SeqLike → GenSeqLike

153. #### def permutations: Iterator[ArrayBuffer[Node]]

     Iterates over distinct permutations.

     Iterates over distinct permutations.

     returns

       An Iterator which traverses the distinct permutations of this arraybuffer.

     Definition Classes
       SeqLike
     Example:

     1. `"abb".permutations = Iterator(abb, bab, bba)`

154. #### def prefixLength(p: (Node) ⇒ Boolean): Int

     Returns the length of the longest prefix whose elements all satisfy some predicate.

     Returns the length of the longest prefix whose elements all satisfy some predicate.

     p

       the predicate used to test elements.

     returns

       the length of the longest prefix of this arraybuffer such that every element of the segment satisfies the predicate `p`.

     Definition Classes
       GenSeqLike

155. #### def prepend(elems: Node*): Unit

     Prepends given elements to this buffer.

     Prepends given elements to this buffer.

     elems

       the elements to prepend.

     Definition Classes
       BufferLike

156. #### def prependAll(xs: TraversableOnce[Node]): Unit

     Prepends the elements contained in a traversable object to this buffer.

     Prepends the elements contained in a traversable object to this buffer.

     xs

       the collection containing the elements to prepend.

     Definition Classes
       BufferLike

157. #### abstract def product: Node

     [use case] Multiplies up the elements of this collection.

     [use case]

     Multiplies up the elements of this collection.

     returns

       the product of all elements of this arraybuffer with respect to the `*` operator in `num`.

     Definition Classes
       GenTraversableOnce

158. #### def product[B >: Node](implicit num: Numeric[B]): B

     Multiplies up the elements of this collection.

     Multiplies up the elements of this collection.

     B

       the result type of the `*` operator.

     num

       an implicit parameter defining a set of numeric operations which includes the `*` operator to be used in forming the product.

     returns

       the product of all elements of this arraybuffer with respect to the `*` operator in `num`.

     Definition Classes
       TraversableOnce → GenTraversableOnce

159. #### def readOnly: Seq[Node]

     Provide a read-only view of this buffer as a sequence

     Provide a read-only view of this buffer as a sequence

     returns

       A sequence which refers to this buffer for all its operations.

     Definition Classes
       BufferLike

160. #### def reduce[A1 >: Node](op: (A1, A1) ⇒ A1): A1

     Reduces the elements of this arraybuffer using the specified associative binary operator.

     Reduces the elements of this arraybuffer using the specified associative binary operator.

     The order in which operations are performed on elements is unspecified and may be nondeterministic.

     A1

       A type parameter for the binary operator, a supertype of `A`.

     op

       A binary operator that must be associative.

     returns

       The result of applying reduce operator `op` between all the elements if the arraybuffer is nonempty.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Exceptions thrown
       UnsupportedOperationException

       if this arraybuffer is empty.

161. #### def reduceLeft[B >: Node](op: (B, Node) ⇒ B): B

     Definition Classes
       IndexedSeqOptimized → TraversableOnce

162. #### def reduceLeftOption[B >: Node](op: (B, Node) ⇒ B): Option[B]

     Optionally applies a binary operator to all elements of this arraybuffer, going left to right.

     Optionally applies a binary operator to all elements of this arraybuffer, going left to right.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceLeft(op)` is this arraybuffer is nonempty, `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

163. #### def reduceOption[A1 >: Node](op: (A1, A1) ⇒ A1): Option[A1]

     Reduces the elements of this arraybuffer, if any, using the specified associative binary operator.

     Reduces the elements of this arraybuffer, if any, using the specified associative binary operator.

     The order in which operations are performed on elements is unspecified and may be nondeterministic.

     A1

       A type parameter for the binary operator, a supertype of `A`.

     op

       A binary operator that must be associative.

     returns

       An option value containing result of applying reduce operator `op` between all the elements if the collection is nonempty, and `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

164. #### def reduceRight[B >: Node](op: (Node, B) ⇒ B): B

     Applies a binary operator to all elements of this arraybuffer, going right to left.

     Applies a binary operator to all elements of this arraybuffer, going right to left.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       the result of inserting `op` between consecutive elements of this arraybuffer, going right to left:

                       op(x,,1,,, op(x,,2,,, ..., op(x,,n-1,,, x,,n,,)...))

       where `x1, ..., xn` are the elements of this arraybuffer.

     Definition Classes
       IndexedSeqOptimized → IterableLike → TraversableOnce → GenTraversableOnce
     Exceptions thrown
       `UnsupportedOperationException`

       if this arraybuffer is empty.

165. #### def reduceRightOption[B >: Node](op: (Node, B) ⇒ B): Option[B]

     Optionally applies a binary operator to all elements of this arraybuffer, going right to left.

     Optionally applies a binary operator to all elements of this arraybuffer, going right to left.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceRight(op)` is this arraybuffer is nonempty, `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

166. #### def reduceToSize(sz: Int): Unit

     remove elements of this array at indices after `sz`

     remove elements of this array at indices after `sz`

     Definition Classes
       ResizableArray

167. #### def remove(n: Int): Node

     Removes the element at a given index position.

     Removes the element at a given index position.

     n

       the index which refers to the element to delete.

     returns

       the element that was formerly at position `n`.

     Definition Classes
       ArrayBuffer → BufferLike

168. #### def remove(n: Int, count: Int): Unit

     Removes the element on a given index position.

     Removes the element on a given index position. It takes time linear in the buffer size.

     n

       the index which refers to the first element to delete.

     count

       the number of elements to delete

     Definition Classes
       ArrayBuffer → BufferLike
     Exceptions thrown
       Predef.IndexOutOfBoundsException

       if `n` is out of bounds.

169. #### def repr: ArrayBuffer[Node]

     The collection of type arraybuffer underlying this `TraversableLike` object.

     The collection of type arraybuffer underlying this `TraversableLike` object. By default this is implemented as the `TraversableLike` object itself, but this can be overridden.

     Definition Classes
       TraversableLike → GenTraversableLike

170. #### def result(): ArrayBuffer[Node]

     Produces a collection from the added elements.

     Produces a collection from the added elements. The builder's contents are undefined after this operation.

     returns

       a collection containing the elements added to this builder.

     Definition Classes
       ArrayBuffer → Builder

171. #### def reverse: ArrayBuffer[Node]

     Returns new arraybuffer wih elements in reversed order.

     Returns new arraybuffer wih elements in reversed order.

     returns

       A new arraybuffer with all elements of this arraybuffer in reversed order.

     Definition Classes
       IndexedSeqOptimized → SeqLike → GenSeqLike

172. #### def reverseIterator: Iterator[Node]

     An iterator yielding elements in reversed order.

     An iterator yielding elements in reversed order.

     Note: `xs.reverseIterator` is the same as `xs.reverse.iterator` but might be more efficient.

     returns

       an iterator yielding the elements of this arraybuffer in reversed order

     Definition Classes
       IndexedSeqOptimized → SeqLike

173. #### abstract def reverseMap[B](f: (Node) ⇒ B): ArrayBuffer[B]

     [use case] Builds a new collection by applying a function to all elements of this arraybuffer and collecting the results in reversed order.

     [use case]

     Builds a new collection by applying a function to all elements of this arraybuffer and collecting the results in reversed order.

     B

       the element type of the returned collection.

     f

       the function to apply to each element.

     returns

       a new collection of type `That` resulting from applying the given function `f` to each element of this arraybuffer and collecting the results in reversed order.

       Note: `xs.reverseMap(f)` is the same as `xs.reverse.map(f)` but might be more efficient.

     Definition Classes
       GenSeqLike

174. #### def reverseMap[B, That](f: (Node) ⇒ B)(implicit bf: CanBuildFrom[ArrayBuffer[Node], B, That]): That

     Builds a new collection by applying a function to all elements of this arraybuffer and collecting the results in reversed order.

     Builds a new collection by applying a function to all elements of this arraybuffer and collecting the results in reversed order.

     Note: `xs.reverseMap(f)` is the same as `xs.reverse.map(f)` but might be more efficient.

     B

       the element type of the returned collection.

     That

       the class of the returned collection. In the standard library configuration, `That` is always `ArrayBuffer[B]` because an implicit of type `CanBuildFrom[ArrayBuffer, B, ArrayBuffer[B]]` is defined in object `ArrayBuffer`.

     f

       the function to apply to each element.

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`. This is usually the `canBuildFrom` value defined in object `ArrayBuffer`.

     returns

       a new collection of type `That` resulting from applying the given function `f` to each element of this arraybuffer and collecting the results in reversed order.

     Definition Classes
       SeqLike → GenSeqLike

175. #### def reversed: List[Node]

     Attributes
       protected[this]
     Definition Classes
       TraversableOnce

176. #### abstract def sameElements(that: GenIterable[Node]): Boolean

     [use case] Checks if the other iterable collection contains the same elements in the same order as this arraybuffer.

     [use case]

     Checks if the other iterable collection contains the same elements in the same order as this arraybuffer.

     that

       the collection to compare with.

     returns

       `true`, if both collections contain the same elements in the same order, `false` otherwise.

     Definition Classes
       GenIterableLike

177. #### def sameElements[B >: Node](that: GenIterable[B]): Boolean

     Checks if the other iterable collection contains the same elements in the same order as this arraybuffer.

     Checks if the other iterable collection contains the same elements in the same order as this arraybuffer.

     B

       the type of the elements of collection `that`.

     that

       the collection to compare with.

     returns

       `true`, if both collections contain the same elements in the same order, `false` otherwise.

     Definition Classes
       IndexedSeqOptimized → IterableLike → GenIterableLike

178. #### def scan[B >: Node, That](z: B)(op: (B, B) ⇒ B)(implicit cbf: CanBuildFrom[ArrayBuffer[Node], B, That]): That

     Computes a prefix scan of the elements of the collection.

     Computes a prefix scan of the elements of the collection.

     Note: The neutral element `z` may be applied more than once.

     B

       element type of the resulting collection

     That

       type of the resulting collection

     z

       neutral element for the operator `op`

     op

       the associative operator for the scan

     cbf

       combiner factory which provides a combiner

     returns

       a new arraybuffer containing the prefix scan of the elements in this arraybuffer

     Definition Classes
       TraversableLike → GenTraversableLike

179. #### def scanLeft[B, That](z: B)(op: (B, Node) ⇒ B)(implicit bf: CanBuildFrom[ArrayBuffer[Node], B, That]): That

     Produces a collection containing cummulative results of applying the operator going left to right.

     Produces a collection containing cummulative results of applying the operator going left to right.

     B

       the type of the elements in the resulting collection

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`. This is usually the `canBuildFrom` value defined in object `ArrayBuffer`.

     returns

       collection with intermediate results

     Definition Classes
       TraversableLike → GenTraversableLike

180. #### def scanRight[B, That](z: B)(op: (Node, B) ⇒ B)(implicit bf: CanBuildFrom[ArrayBuffer[Node], B, That]): That

     Produces a collection containing cummulative results of applying the operator going right to left.

     Produces a collection containing cummulative results of applying the operator going right to left. The head of the collection is the last cummulative result.

     Example:

            List(1, 2, 3, 4).scanRight(0)(_ + _) == List(10, 9, 7, 4, 0)

     B

       the type of the elements in the resulting collection

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`. This is usually the `canBuildFrom` value defined in object `ArrayBuffer`.

     returns

       collection with intermediate results

     Definition Classes
       TraversableLike → GenTraversableLike
     Annotations
       @migration
     Migration

       (Changed in version 2.9.0) The behavior of `scanRight` has changed. The previous behavior can be reproduced with scanRight.reverse.

181. #### def segmentLength(p: (Node) ⇒ Boolean, from: Int): Int

     Computes length of longest segment whose elements all satisfy some predicate.

     Computes length of longest segment whose elements all satisfy some predicate.

     p

       the predicate used to test elements.

     from

       the index where the search starts.

     returns

       the length of the longest segment of this arraybuffer starting from index `from` such that every element of the segment satisfies the predicate `p`.

     Definition Classes
       IndexedSeqOptimized → SeqLike → GenSeqLike

182. #### def seq: Seq[Node]

     A version of this collection with all of the operations implemented sequentially (i.

     A version of this collection with all of the operations implemented sequentially (i.e. in a single-threaded manner).

     This method returns a reference to this collection. In parallel collections, it is redefined to return a sequential implementation of this collection. In both cases, it has O(1) complexity.

     returns

       a sequential view of the collection.

     Definition Classes
       Seq → Seq → GenSeq → Iterable → Iterable → GenIterable → Traversable → Traversable → GenTraversable → Parallelizable → TraversableOnce → GenTraversableOnce

183. #### def size: Int

     The size of this arraybuffer, equivalent to `length`.

     The size of this arraybuffer, equivalent to `length`.

     returns

       the number of elements in this arraybuffer.

     Definition Classes
       SeqLike → GenTraversableLike → TraversableOnce → GenTraversableOnce

184. #### var size0: Int

     Attributes
       protected
     Definition Classes
       ResizableArray

185. #### def sizeHint(len: Int): Unit

     Gives a hint how many elements are expected to be added when the next `result` is called.

     Gives a hint how many elements are expected to be added when the next `result` is called. Some builder classes will optimize their representation based on the hint. However, builder implementations are still required to work correctly even if the hint is wrong, i.e. a different number of elements is added.

     Definition Classes
       ArrayBuffer → Builder

186. #### def sizeHint(coll: scala.collection.TraversableLike[_, _], delta: Int = 0): Unit

     Gives a hint that one expects the `result` of this builder to have the same size as the given collection, plus some delta.

     Gives a hint that one expects the `result` of this builder to have the same size as the given collection, plus some delta. This will provide a hint only if the collection is known to have a cheap `size` method. Currently this is assumed to be the case if and only if the collection is of type `IndexedSeqLike`. Some builder classes will optimize their representation based on the hint. However, builder implementations are still required to work correctly even if the hint is wrong, i.e. a different number of elements is added.

     coll

       the collection which serves as a hint for the result's size.

     delta

       a correction to add to the `coll.size` to produce the size hint.

     Definition Classes
       Builder

187. #### def sizeHintBounded(size: Int, boundingColl: scala.collection.TraversableLike[_, _]): Unit

     Gives a hint how many elements are expected to be added when the next `result` is called, together with an upper bound given by the size of some other collection.

     Gives a hint how many elements are expected to be added when the next `result` is called, together with an upper bound given by the size of some other collection. Some builder classes will optimize their representation based on the hint. However, builder implementations are still required to work correctly even if the hint is wrong, i.e. a different number of elements is added.

     size

       the hint how many elements will be added.

     boundingColl

       the bounding collection. If it is an IndexedSeqLike, then sizes larger than collection's size are reduced.

     Definition Classes
       Builder

188. #### def slice(from: Int, until: Int): ArrayBuffer[Node]

     Selects an interval of elements.

     Selects an interval of elements. The returned collection is made up of all elements `x` which satisfy the invariant:

            from <= indexOf(x) < until

     from

       the lowest index to include from this arraybuffer.

     until

       the highest index to EXCLUDE from this arraybuffer.

     returns

       a arraybuffer containing the elements greater than or equal to index `from` extending up to (but not including) index `until` of this arraybuffer.

     Definition Classes
       IndexedSeqOptimized → IterableLike → TraversableLike → GenTraversableLike

189. #### def sliding[B >: Node](size: Int, step: Int): Iterator[ArrayBuffer[Node]]

     Definition Classes
       IterableLike

190. #### def sliding[B >: Node](size: Int): Iterator[ArrayBuffer[Node]]

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.)

     size

       the number of elements per group

     returns

       An iterator producing arraybuffers of size `size`, except the last and the only element will be truncated if there are fewer elements than size.

     Definition Classes
       IterableLike
     See also

       Iterator#sliding

191. #### def sortBy[B](f: (Node) ⇒ B)(implicit ord: Ordering[B]): ArrayBuffer[Node]

     Sorts this ArrayBuffer according to the Ordering which results from transforming an implicitly given Ordering with a transformation function.

     Sorts this ArrayBuffer according to the Ordering which results from transforming an implicitly given Ordering with a transformation function.

     B

       the target type of the transformation `f`, and the type where the ordering `ord` is defined.

     f

       the transformation function mapping elements to some other domain `B`.

     ord

       the ordering assumed on domain `B`.

     returns

       a arraybuffer consisting of the elements of this arraybuffer sorted according to the ordering where `x < y` if `ord.lt(f(x), f(y))`.

     Definition Classes
       SeqLike
     Example:

     1.        val words = "The quick brown fox jumped over the lazy dog".split(' ')
               // this works because scala.Ordering will implicitly provide an Ordering[Tuple2[Int, Char]]
               words.sortBy(x => (x.length, x.head))
               res0: Array[String] = Array(The, dog, fox, the, lazy, over, brown, quick, jumped)

     See also

       scala.math.Ordering

192. #### def sortWith(lt: (Node, Node) ⇒ Boolean): ArrayBuffer[Node]

     Sorts this arraybuffer according to a comparison function.

     Sorts this arraybuffer according to a comparison function.

     The sort is stable. That is, elements that are equal wrt `lt` appear in the same order in the sorted sequence as in the original.

     lt

       the comparison function which tests whether its first argument precedes its second argument in the desired ordering.

     returns

       a arraybuffer consisting of the elements of this arraybuffer sorted according to the comparison function `lt`.

     Definition Classes
       SeqLike
     Example:

     1.        List("Steve", "Tom", "John", "Bob").sortWith(_.compareTo(_) < 0) =
               List("Bob", "John", "Steve", "Tom")

193. #### def sorted[B >: Node](implicit ord: Ordering[B]): ArrayBuffer[Node]

     Sorts this arraybuffer according to an Ordering.

     Sorts this arraybuffer according to an Ordering.

     The sort is stable. That is, elements that are equal wrt `lt` appear in the same order in the sorted sequence as in the original.

     ord

       the ordering to be used to compare elements.

     returns

       a arraybuffer consisting of the elements of this arraybuffer sorted according to the ordering `ord`.

     Definition Classes
       SeqLike
     See also

       scala.math.Ordering

194. #### def span(p: (Node) ⇒ Boolean): (ArrayBuffer[Node], ArrayBuffer[Node])

     Splits this arraybuffer into a prefix/suffix pair according to a predicate.

     Splits this arraybuffer into a prefix/suffix pair according to a predicate.

     Note: `c span p` is equivalent to (but possibly more efficient than) `(c takeWhile p, c dropWhile p)`, provided the evaluation of the predicate `p` does not cause any side-effects.

     p

       the test predicate

     returns

       a pair consisting of the longest prefix of this arraybuffer whose elements all satisfy `p`, and the rest of this arraybuffer.

     Definition Classes
       IndexedSeqOptimized → TraversableLike → GenTraversableLike

195. #### def splitAt(n: Int): (ArrayBuffer[Node], ArrayBuffer[Node])

     Splits this arraybuffer into two at a given position.

     Splits this arraybuffer into two at a given position. Note: `c splitAt n` is equivalent to (but possibly more efficient than) `(c take n, c drop n)`.

     n

       the position at which to split.

     returns

       a pair of arraybuffers consisting of the first `n` elements of this arraybuffer, and the other elements.

     Definition Classes
       IndexedSeqOptimized → TraversableLike → GenTraversableLike

196. #### def startsWith[B](that: GenSeq[B], offset: Int): Boolean

     Tests whether this arraybuffer contains the given sequence at a given index.

     Tests whether this arraybuffer contains the given sequence at a given index.

     If the both the receiver object, `this` and the argument, `that` are infinite sequences this method may not terminate.

     that

       the sequence to test

     offset

       the index where the sequence is searched.

     returns

       `true` if the sequence `that` is contained in this arraybuffer at index `offset`, otherwise `false`.

     Definition Classes
       IndexedSeqOptimized → SeqLike → GenSeqLike

197. #### def startsWith[B](that: GenSeq[B]): Boolean

     Tests whether this arraybuffer starts with the given sequence.

     Tests whether this arraybuffer starts with the given sequence.

     that

       the sequence to test

     returns

       `true` if this collection has `that` as a prefix, `false` otherwise.

     Definition Classes
       GenSeqLike

198. #### def stringPrefix: String

     Defines the prefix of the string representation.

     Defines the prefix of the string representation.

     returns

       a string representation which starts the result of `toString` applied to this set. Unless overridden this is simply `"Buffer"`.

     Definition Classes
       ArrayBuffer → BufferLike → TraversableLike → GenTraversableLike

199. #### abstract def sum: Node

     [use case] Sums up the elements of this collection.

     [use case]

     Sums up the elements of this collection.

     returns

       the sum of all elements of this arraybuffer with respect to the `+` operator in `num`.

     Definition Classes
       GenTraversableOnce

200. #### def sum[B >: Node](implicit num: Numeric[B]): B

     Sums up the elements of this collection.

     Sums up the elements of this collection.

     B

       the result type of the `+` operator.

     num

       an implicit parameter defining a set of numeric operations which includes the `+` operator to be used in forming the sum.

     returns

       the sum of all elements of this arraybuffer with respect to the `+` operator in `num`.

     Definition Classes
       TraversableOnce → GenTraversableOnce

201. #### def swap(a: Int, b: Int): Unit

     Swap two elements of this array.

     Swap two elements of this array.

     Attributes
       protected
     Definition Classes
       ResizableArray

202. #### final def synchronized[T0](arg0: ⇒ T0): T0

     Definition Classes
       AnyRef

203. #### def tail: ArrayBuffer[Node]

     Selects all elements except the first.

     Selects all elements except the first.

     returns

       a arraybuffer consisting of all elements of this arraybuffer except the first one.

     Definition Classes
       IndexedSeqOptimized → TraversableLike → GenTraversableLike
     Exceptions thrown
       `UnsupportedOperationException`

       if the arraybuffer is empty.

204. #### def tails: Iterator[ArrayBuffer[Node]]

     Iterates over the tails of this arraybuffer.

     Iterates over the tails of this arraybuffer. The first value will be this arraybuffer and the final one will be an empty arraybuffer, with the intervening values the results of successive applications of `tail`.

     returns

       an iterator over all the tails of this arraybuffer

     Definition Classes
       TraversableLike
     Example:

     1. `List(1,2,3).tails = Iterator(List(1,2,3), List(2,3), List(3), Nil)`

205. #### def take(n: Int): ArrayBuffer[Node]

     Selects first n elements.

     Selects first n elements.

     n

       Tt number of elements to take from this arraybuffer.

     returns

       a arraybuffer consisting only of the first `n` elements of this arraybuffer, or else the whole arraybuffer, if it has less than `n` elements.

     Definition Classes
       IndexedSeqOptimized → IterableLike → TraversableLike → GenTraversableLike

206. #### def takeRight(n: Int): ArrayBuffer[Node]

     Selects last n elements.

     Selects last n elements.

     n

       the number of elements to take

     returns

       a arraybuffer consisting only of the last `n` elements of this arraybuffer, or else the whole arraybuffer, if it has less than `n` elements.

     Definition Classes
       IndexedSeqOptimized → IterableLike

207. #### def takeWhile(p: (Node) ⇒ Boolean): ArrayBuffer[Node]

     Takes longest prefix of elements that satisfy a predicate.

     Takes longest prefix of elements that satisfy a predicate.

     p

       The predicate used to test elements.

     returns

       the longest prefix of this arraybuffer whose elements all satisfy the predicate `p`.

     Definition Classes
       IndexedSeqOptimized → IterableLike → TraversableLike → GenTraversableLike

208. #### def thisCollection: IndexedSeq[Node]

     The underlying collection seen as an instance of `ArrayBuffer`.

     The underlying collection seen as an instance of `ArrayBuffer`. By default this is implemented as the current collection object itself, but this can be overridden.

     Attributes
       protected[this]
     Definition Classes
       IndexedSeqLike → IndexedSeqLike → SeqLike → IterableLike → TraversableLike

209. #### abstract def toArray: Array[Node]

     [use case] Converts this arraybuffer to an array.

     [use case]

     Converts this arraybuffer to an array.

     returns

       an array containing all elements of this arraybuffer.

     Definition Classes
       GenTraversableOnce

210. #### def toArray[B >: Node](implicit arg0: ClassManifest[B]): Array[B]

     Converts this arraybuffer to an array.

     Converts this arraybuffer to an array.

     B

       the type of the elements of the array. A `ClassManifest` for this type must be available.

     returns

       an array containing all elements of this arraybuffer.

     Definition Classes
       TraversableOnce → GenTraversableOnce

211. #### def toBuffer[A1 >: Node]: Buffer[A1]

     Overridden for efficiency

     Overridden for efficiency

     returns

       a buffer containing all elements of this arraybuffer.

     Definition Classes
       IndexedSeqLike → TraversableOnce → GenTraversableOnce

212. #### def toCollection(repr: ArrayBuffer[Node]): IndexedSeq[Node]

     A conversion from collections of type `Repr` to `ArrayBuffer` objects.

     A conversion from collections of type `Repr` to `ArrayBuffer` objects. By default this is implemented as just a cast, but this can be overridden.

     Attributes
       protected[this]
     Definition Classes
       IndexedSeqLike → IndexedSeqLike → SeqLike → IterableLike → TraversableLike

213. #### def toIndexedSeq[B >: Node]: IndexedSeq[B]

     Converts this arraybuffer to an indexed sequence.

     Converts this arraybuffer to an indexed sequence.

     returns

       an indexed sequence containing all elements of this arraybuffer.

     Definition Classes
       TraversableOnce → GenTraversableOnce

214. #### def toIterable: Iterable[Node]

     Converts this arraybuffer to an iterable collection.

     Converts this arraybuffer to an iterable collection. Note that the choice of target `Iterable` is lazy in this default implementation as this `TraversableOnce` may be lazy and unevaluated (i.e. it may be an iterator which is only traversable once).

     returns

       an `Iterable` containing all elements of this arraybuffer.

     Definition Classes
       IterableLike → TraversableOnce → GenTraversableOnce

215. #### def toIterator: Iterator[Node]

     Returns an Iterator over the elements in this arraybuffer.

     Returns an Iterator over the elements in this arraybuffer. Will return the same Iterator if this instance is already an Iterator.

     returns

       an Iterator containing all elements of this arraybuffer.

     Definition Classes
       TraversableLike → GenTraversableOnce

216. #### def toList: List[Node]

     Converts this arraybuffer to a list.

     Converts this arraybuffer to a list.

     returns

       a list containing all elements of this arraybuffer.

     Definition Classes
       TraversableOnce → GenTraversableOnce

217. #### abstract def toMap[T, U]: Map[T, U]

     [use case] Converts this arraybuffer to a map.

     [use case]

     Converts this arraybuffer to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     returns

       a map containing all elements of this arraybuffer.

     Definition Classes
       GenTraversableOnce

218. #### def toMap[T, U](implicit ev: <:<[Node, (T, U)]): Map[T, U]

     Converts this arraybuffer to a map.

     Converts this arraybuffer to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     returns

       a map containing all elements of this arraybuffer.

     Definition Classes
       TraversableOnce → GenTraversableOnce

219. #### def toSeq: Seq[Node]

     Converts this arraybuffer to a sequence.

     Converts this arraybuffer to a sequence.

     Overridden for efficiency.

     returns

       a sequence containing all elements of this arraybuffer.

     Definition Classes
       SeqLike → GenSeqLike → TraversableOnce → GenTraversableOnce

220. #### def toSet[B >: Node]: Set[B]

     Converts this arraybuffer to a set.

     Converts this arraybuffer to a set.

     returns

       a set containing all elements of this arraybuffer.

     Definition Classes
       TraversableOnce → GenTraversableOnce

221. #### def toStream: Stream[Node]

     Converts this arraybuffer to a stream.

     Converts this arraybuffer to a stream.

     returns

       a stream containing all elements of this arraybuffer.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableOnce

222. #### def toString(): String

     Converts this arraybuffer to a string.

     Converts this arraybuffer to a string.

     returns

       a string representation of this collection. By default this string consists of the `stringPrefix` of this arraybuffer, followed by all elements separated by commas and enclosed in parentheses.

     Definition Classes
       SeqLike → TraversableLike → AnyRef → Any

223. #### def toTraversable: Traversable[Node]

     Converts this arraybuffer to an unspecified Traversable.

     Converts this arraybuffer to an unspecified Traversable. Will return the same collection if this instance is already Traversable.

     returns

       a Traversable containing all elements of this arraybuffer.

     Definition Classes
       TraversableLike → TraversableOnce → GenTraversableOnce

224. #### def transform(f: (Node) ⇒ Node): NodeBuffer.this.type

     Applies a transformation function to all values contained in this sequence.

     Applies a transformation function to all values contained in this sequence. The transformation function produces new values from existing elements.

     f

       the transformation to apply

     returns

       the sequence itself.

     Definition Classes
       SeqLike

225. #### def transpose[B](implicit asTraversable: (Node) ⇒ GenTraversableOnce[B]): ArrayBuffer[ArrayBuffer[B]]

     Transposes this arraybuffer of traversable collections into a arraybuffer of arraybuffers.

     Transposes this arraybuffer of traversable collections into a arraybuffer of arraybuffers.

     B

       the type of the elements of each traversable collection.

     asTraversable

       an implicit conversion which asserts that the element type of this arraybuffer is a `Traversable`.

     returns

       a two-dimensional arraybuffer of arraybuffers which has as nth row the nth column of this arraybuffer.

     Definition Classes
       GenericTraversableTemplate
     Annotations
       @migration
     Migration

       (Changed in version 2.9.0) `transpose` throws an `IllegalArgumentException` if collections are not uniformly sized.

     Exceptions thrown
       `IllegalArgumentException`

       if all collections in this arraybuffer are not of the same size.

226. #### def trimEnd(n: Int): Unit

     Removes the last n elements of this buffer.

     Removes the last n elements of this buffer.

     n

       the number of elements to remove from the end of this buffer.

     Definition Classes
       BufferLike

227. #### def trimStart(n: Int): Unit

     Removes the first n elements of this buffer.

     Removes the first n elements of this buffer.

     n

       the number of elements to remove from the beginning of this buffer.

     Definition Classes
       BufferLike

228. #### abstract def union(that: Seq[Node]): ArrayBuffer[Node]

     [use case] Produces a new sequence which contains all elements of this arraybuffer and also all elements of a given sequence.

     [use case]

     Produces a new sequence which contains all elements of this arraybuffer and also all elements of a given sequence. `xs union ys` is equivalent to `xs ++ ys`.

     that

       the sequence to add.

     returns

       a new collection of type `That` which contains all elements of this arraybuffer followed by all elements of `that`.

     Definition Classes
       SeqLike

229. #### def union[B >: Node, That](that: GenSeq[B])(implicit bf: CanBuildFrom[ArrayBuffer[Node], B, That]): That

     Produces a new sequence which contains all elements of this arraybuffer and also all elements of a given sequence.

     Produces a new sequence which contains all elements of this arraybuffer and also all elements of a given sequence. `xs union ys` is equivalent to `xs ++ ys`.

     Another way to express this is that `xs union ys` computes the order-presevring multi-set union of `xs` and `ys`. `union` is hence a counter-part of `diff` and `intersect` which also work on multi-sets.

     B

       the element type of the returned arraybuffer.

     That

       the class of the returned collection. In the standard library configuration, `That` is always `ArrayBuffer[B]` because an implicit of type `CanBuildFrom[ArrayBuffer, B, ArrayBuffer[B]]` is defined in object `ArrayBuffer`.

     that

       the sequence to add.

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`. This is usually the `canBuildFrom` value defined in object `ArrayBuffer`.

     returns

       a new collection of type `That` which contains all elements of this arraybuffer followed by all elements of `that`.

     Definition Classes
       SeqLike → GenSeqLike

230. #### def unzip[A1, A2](implicit asPair: (Node) ⇒ (A1, A2)): (ArrayBuffer[A1], ArrayBuffer[A2])

     Converts this arraybuffer of pairs into two collections of the first and second half of each pair.

     Converts this arraybuffer of pairs into two collections of the first and second half of each pair.

     asPair

       an implicit conversion which asserts that the element type of this arraybuffer is a pair.

     returns

       a pair arraybuffers, containing the first, respectively second half of each element pair of this arraybuffer.

     Definition Classes
       GenericTraversableTemplate

231. #### def unzip3[A1, A2, A3](implicit asTriple: (Node) ⇒ (A1, A2, A3)): (ArrayBuffer[A1], ArrayBuffer[A2], ArrayBuffer[A3])

     Converts this arraybuffer of triples into three collections of the first, second, and third element of each triple.

     Converts this arraybuffer of triples into three collections of the first, second, and third element of each triple.

     asTriple

       an implicit conversion which asserts that the element type of this arraybuffer is a triple.

     returns

       a triple arraybuffers, containing the first, second, respectively third member of each element triple of this arraybuffer.

     Definition Classes
       GenericTraversableTemplate

232. #### def update(idx: Int, elem: Node): Unit

     Replaces element at given index with a new value.

     Replaces element at given index with a new value.

     elem

       the new value.

     Definition Classes
       ResizableArray → IndexedSeqLike → SeqLike
     Exceptions thrown
       IndexOutOfBoundsException

       if the index is not valid.

233. #### abstract def updated(index: Int, elem: Node): ArrayBuffer[Node]

     [use case] A copy of this arraybuffer with one single replaced element.

     [use case]

     A copy of this arraybuffer with one single replaced element.

     index

       the position of the replacement

     elem

       the replacing element

     returns

       a new arraybuffer`which is a copy of this arraybuffer with the element at position` index`replaced by` elem`.`

     Definition Classes
       GenSeqLike

234. #### def updated[B >: Node, That](index: Int, elem: B)(implicit bf: CanBuildFrom[ArrayBuffer[Node], B, That]): That

     A copy of this arraybuffer with one single replaced element.

     A copy of this arraybuffer with one single replaced element.

     B

       the element type of the returned arraybuffer.

     That

       the class of the returned collection. In the standard library configuration, `That` is always `ArrayBuffer[B]` because an implicit of type `CanBuildFrom[ArrayBuffer, B, ArrayBuffer[B]]` is defined in object `ArrayBuffer`.

     index

       the position of the replacement

     elem

       the replacing element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`. This is usually the `canBuildFrom` value defined in object `ArrayBuffer`.

     returns

       a new arraybuffer`which is a copy of this arraybuffer with the element at position` index`replaced by` elem`.`

     Definition Classes
       SeqLike → GenSeqLike

235. #### def view(from: Int, until: Int): IndexedSeqView[Node, ArrayBuffer[Node]]

     A sub-sequence view starting at index `from` and extending up to (but not including) index `until`.

     A sub-sequence view starting at index `from` and extending up to (but not including) index `until`.

     from

       The index of the first element of the slice

     until

       The index of the element following the slice

     returns

       a non-strict view of a slice of this arraybuffer, starting at index `from` and extending up to (but not including) index `until`.@note The difference between `view` and `slice` is that `view` produces a view of the current sequence, whereas `slice` produces a new sequence.

     Definition Classes
       IndexedSeqLike → SeqLike → IterableLike → TraversableLike
     Note

       view(from, to) is equivalent to view.slice(from, to)

236. #### def view: IndexedSeqView[Node, ArrayBuffer[Node]]

     Creates a view of this iterable @see Iterable.

     Creates a view of this iterable @see Iterable.View

     returns

       a non-strict view of this arraybuffer.

     Definition Classes
       IndexedSeqLike → SeqLike → IterableLike → TraversableLike

237. #### final def wait(): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

238. #### final def wait(arg0: Long, arg1: Int): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

239. #### final def wait(arg0: Long): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

240. #### def withFilter(p: (Node) ⇒ Boolean): FilterMonadic[Node, ArrayBuffer[Node]]

     Creates a non-strict filter of this arraybuffer.

     Creates a non-strict filter of this arraybuffer.

     Note: the difference between `c filter p` and `c withFilter p` is that the former creates a new collection, whereas the latter only restricts the domain of subsequent `map`, `flatMap`, `foreach`, and `withFilter` operations.

     p

       the predicate used to test elements.

     returns

       an object of class `WithFilter`, which supports `map`, `flatMap`, `foreach`, and `withFilter` operations. All these operations apply to those elements of this arraybuffer which satisfy the predicate `p`.

     Definition Classes
       TraversableLike → FilterMonadic

241. #### abstract def zip[B](that: GenIterable[B]): ArrayBuffer[(Node, B)]

     [use case] Returns a arraybuffer formed from this arraybuffer and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a arraybuffer formed from this arraybuffer and another iterable collection by combining corresponding elements in pairs. If one of the two collections is longer than the other, its remaining elements are ignored.

     B

       the type of the second half of the returned pairs

     that

       The iterable providing the second half of each result pair

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this arraybuffer and `that`. The length of the returned collection is the minimum of the lengths of this arraybuffer and `that`.

     Definition Classes
       GenIterableLike

242. #### def zip[A1 >: Node, B, That](that: GenIterable[B])(implicit bf: CanBuildFrom[ArrayBuffer[Node], (A1, B), That]): That

     Returns a arraybuffer formed from this arraybuffer and another iterable collection by combining corresponding elements in pairs.

     Returns a arraybuffer formed from this arraybuffer and another iterable collection by combining corresponding elements in pairs. If one of the two collections is longer than the other, its remaining elements are ignored.

     A1

       the type of the first half of the returned pairs (this is always a supertype of the collection's element type `A`).

     B

       the type of the second half of the returned pairs

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `(A1, B)` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, (A1, B), That]`. is found.

     that

       The iterable providing the second half of each result pair

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `(A1, B)`.

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this arraybuffer and `that`. The length of the returned collection is the minimum of the lengths of this arraybuffer and `that`.

     Definition Classes
       IndexedSeqOptimized → IterableLike → GenIterableLike

243. #### abstract def zipAll[B](that: Iterable[B], thisElem: Node, thatElem: B): ArrayBuffer[(Node, B)]

     [use case] Returns a arraybuffer formed from this arraybuffer and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a arraybuffer formed from this arraybuffer and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

     that

       the iterable providing the second half of each result pair

     thisElem

       the element to be used to fill up the result if this arraybuffer is shorter than `that`.

     thatElem

       the element to be used to fill up the result if `that` is shorter than this arraybuffer.

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this arraybuffer and `that`. The length of the returned collection is the maximum of the lengths of this arraybuffer and `that`. If this arraybuffer is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this arraybuffer, `thatElem` values are used to pad the result.

     Definition Classes
       GenIterableLike

244. #### def zipAll[B, A1 >: Node, That](that: GenIterable[B], thisElem: A1, thatElem: B)(implicit bf: CanBuildFrom[ArrayBuffer[Node], (A1, B), That]): That

     Returns a arraybuffer formed from this arraybuffer and another iterable collection by combining corresponding elements in pairs.

     Returns a arraybuffer formed from this arraybuffer and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

     that

       the iterable providing the second half of each result pair

     thisElem

       the element to be used to fill up the result if this arraybuffer is shorter than `that`.

     thatElem

       the element to be used to fill up the result if `that` is shorter than this arraybuffer.

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this arraybuffer and `that`. The length of the returned collection is the maximum of the lengths of this arraybuffer and `that`. If this arraybuffer is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this arraybuffer, `thatElem` values are used to pad the result.

     Definition Classes
       IterableLike → GenIterableLike

245. #### abstract def zipWithIndex: ArrayBuffer[(Node, Int)]

     [use case] Zips this arraybuffer with its indices.

     [use case]

     Zips this arraybuffer with its indices.

     returns

       A new collection of type `That` containing pairs consisting of all elements of this arraybuffer paired with their index. Indices start at `0`.

     Definition Classes
       GenIterableLike

246. #### def zipWithIndex[A1 >: Node, That](implicit bf: CanBuildFrom[ArrayBuffer[Node], (A1, Int), That]): That

     Zips this arraybuffer with its indices.

     Zips this arraybuffer with its indices.

     A1

       the type of the first half of the returned pairs (this is always a supertype of the collection's element type `A`).

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `(A1, Int)` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, (A1, Int), That]`. is found.

     returns

       A new collection of type `That` containing pairs consisting of all elements of this arraybuffer paired with their index. Indices start at `0`.

     Definition Classes
       IndexedSeqOptimized → IterableLike → GenIterableLike

### Deprecated Value Members

1. #### def +(elem1: Node, elem2: Node, elems: Node*): ArrayBuffer[Node]

   Adds two or more elements to this collection and returns the collection itself.

   Adds two or more elements to this collection and returns the collection itself.

   Note that for backward compatibility reasons, this method mutates the collection in place, unlike similar but undeprecated methods throughout the collections hierarchy. You are strongly recommended to use '++=' instead.

   elem1

     the first element to add.

   elem2

     the second element to add.

   elems

     the remaining elements to add.

   Definition Classes
     BufferLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) "Use ++= instead if you intend to add by side effect to an existing collection.\012".+("Use `clone() ++=\' if you intend to create a new collection.")`

2. #### def +(elem: Node): ArrayBuffer[Node]

   Adds a single element to this collection and returns the collection itself.

   Adds a single element to this collection and returns the collection itself.

   Note that for backward compatibility reasons, this method mutates the collection in place, unlike similar but undeprecated methods throughout the collections hierarchy. You are strongly recommended to use '+=' instead.

   elem

     the element to add.

   Definition Classes
     BufferLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) "Use += instead if you intend to add by side effect to an existing collection.\012".+("Use `clone() +=\' if you intend to create a new collection.")`

3. #### def ++=(src: Array[Node], start: Int, len: Int): Unit

   Adds a number of elements in an array

   Adds a number of elements in an array

   src

     the array

   start

     the first element to append

   len

     the number of elements to append

   Definition Classes
     BufferLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) replace by: `buf ++= src.view(start, end)`

4. #### def elements: Iterator[Node]

   Definition Classes
     IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `iterator' instead`

5. #### def equalsWith[B](that: Seq[B])(f: (Node, B) ⇒ Boolean): Boolean

   Tests whether every element of this arraybuffer relates to the corresponding element of another sequence by satisfying a test predicate.

   Tests whether every element of this arraybuffer relates to the corresponding element of another sequence by satisfying a test predicate.

   B

     the type of the elements of `that`

   that

     the other sequence

   returns

     `true` if both sequences have the same length and `p(x, y)` is `true` for all corresponding elements `x` of this arraybuffer and `y` of `that`, otherwise `false`.

   Definition Classes
     SeqLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `corresponds` instead

6. #### def findIndexOf(p: (Node) ⇒ Boolean): Int

   Returns index of the first element satisfying a predicate, or `-1`.

   Returns index of the first element satisfying a predicate, or `-1`.

   Definition Classes
     SeqLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) Use indexWhere(p) instead.

7. #### def findLastIndexOf(p: (Node) ⇒ Boolean): Int

   Returns index of the last element satisfying a predicate, or -1.

   Returns index of the last element satisfying a predicate, or -1.

   Definition Classes
     SeqLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `lastIndexWhere` instead

8. #### def first: Node

   Definition Classes
     IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `head' instead`

9. #### def firstOption: Option[Node]

   `None` if iterable is empty.

   `None` if iterable is empty.

   Definition Classes
     IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `headOption' instead`

10. #### def projection: SeqView[Node, ArrayBuffer[Node]]

    returns a projection that can be used to call non-strict `filter`, `map`, and `flatMap` methods that build projections of the collection.

    returns a projection that can be used to call non-strict `filter`, `map`, and `flatMap` methods that build projections of the collection.

    Definition Classes
      SeqLike → IterableLike
    Annotations
      @deprecated
    Deprecated

      (Since version 2.8.0) use `view' instead`

11. #### def reversedElements: Iterator[Node]

    Definition Classes
      SeqLike
    Annotations
      @deprecated
    Deprecated

      (Since version 2.8.0) use `reverseIterator' instead`

### Inherited from ArrayBuffer[Node]

### Inherited from Serializable

### Inherited from CustomParallelizable[Node, ParArray[Node]]

### Inherited from ResizableArray[Node]

### Inherited from IndexedSeq[Node]

### Inherited from Builder[Node, ArrayBuffer[Node]]

### Inherited from IndexedSeqOptimized[Node, ArrayBuffer[Node]]

### Inherited from IndexedSeqLike[Node, ArrayBuffer[Node]]

### Inherited from Buffer[Node]

### Inherited from BufferLike[Node, ArrayBuffer[Node]]

### Inherited from Subtractable[Node, ArrayBuffer[Node]]

### Inherited from Scriptable[Node]

### Inherited from Shrinkable[Node]

### Inherited from Growable[Node]

### Inherited from Seq[Node]

### Inherited from SeqLike[Node, ArrayBuffer[Node]]

### Inherited from Cloneable[ArrayBuffer[Node]]

### Inherited from Seq[Node]

### Inherited from SeqLike[Node, ArrayBuffer[Node]]

### Inherited from GenSeq[Node]

### Inherited from GenSeqLike[Node, ArrayBuffer[Node]]

### Inherited from PartialFunction[Int, Node]

### Inherited from (Int) ⇒ Node

### Inherited from Iterable[Node]

### Inherited from IterableLike[Node, ArrayBuffer[Node]]

### Inherited from Equals

### Inherited from GenIterable[Node]

### Inherited from GenIterableLike[Node, ArrayBuffer[Node]]

### Inherited from Traversable[Node]

### Inherited from Mutable

### Inherited from Traversable[Node]

### Inherited from GenTraversable[Node]

### Inherited from GenericTraversableTemplate[Node, ArrayBuffer]

### Inherited from TraversableLike[Node, ArrayBuffer[Node]]

### Inherited from GenTraversableLike[Node, ArrayBuffer[Node]]

### Inherited from Parallelizable[Node, ParArray[Node]]

### Inherited from TraversableOnce[Node]

### Inherited from GenTraversableOnce[Node]

### Inherited from FilterMonadic[Node, ArrayBuffer[Node]]

### Inherited from HasNewBuilder[Node, ArrayBuffer[Node]]

### Inherited from AnyRef

### Inherited from Any